// Bitmap.h
// BMP SAVING ROUTINES
// (c) 3LblDEHb [Team 16]

#ifndef __bitmap_h
#define __bitmap_h

////////////////////////////////////////////////////////////
//     
////////////////////////////////////////////////////////////
void SaveBitmap(char *file)
{
	HANDLE				bmp;	
	BITMAPFILEHEADER	bmphead;
	BITMAPINFO			bmpinfo;
	BITMAPINFOHEADER	bmpinfohead;
	COLORREF			col;
	HGLOBAL				bits_mem;
	static BYTE			*bits;
	static int			w,x,y,xm,ym;
	DWORD				size;

	SetCursor(LoadCursor(NULL,IDC_WAIT));
	SelectObject(hCompDC,hbitmap);
	GetObject(hbitmap,sizeof(BITMAP),&bitmap);
	xm=w=bitmap.bmWidth; ym=bitmap.bmHeight;
	(w*3)%4==0?temp1=0:temp1=4-(w*3)%4;	
	size=(xm*3+temp1)*ym;
	bits_mem=GlobalAlloc(0,size);
	if (bits_mem==NULL)
	{
		DANGMESSAGE(" !!!");
		return;
	}
	bits=(BYTE*)GlobalLock(bits_mem);
	y=ym-1; x=0;
	while (y>=0)
	{
		while (x<xm)
		{
			col=GetPixel(hCompDC,x,y);
			bits[x*3+(ym-1-y)*xm*3+temp1*(ym-1-y)]=(col&0xff0000)>>16;
			bits[x*3+(ym-1-y)*xm*3+1+temp1*(ym-1-y)]=(col&0xff00)>>8;
			bits[x*3+(ym-1-y)*xm*3+2+temp1*(ym-1-y)]=(col&0xff);
			x++;
		}
		for (temp=0; temp<temp1; temp++)
			bits[3*x+(ym-1-y)*xm*3+temp1*(ym-1-y)+temp]=0;
		y--; x=0;
	}

	bmphead.bfType=0x4D42;
	bmphead.bfSize=size+54;
	bmphead.bfReserved1=bmphead.bfReserved2=0;
	bmphead.bfOffBits=54;
	bmpinfohead.biSize=sizeof(BITMAPINFOHEADER);
	bmpinfohead.biWidth=xm;
	bmpinfohead.biHeight=ym;
	bmpinfohead.biPlanes=1;
	bmpinfohead.biBitCount=24;
	bmpinfohead.biCompression=BI_RGB;
	bmpinfohead.biSizeImage=size;
	bmpinfohead.biXPelsPerMeter=bmpinfohead.biYPelsPerMeter=0;
	bmpinfohead.biClrUsed=0;
	bmpinfohead.biClrImportant=0;
	bmpinfo.bmiHeader=bmpinfohead;
	bmp=CreateFile(file,GENERIC_WRITE,0,0,CREATE_ALWAYS,0,0);
	if (bmp==INVALID_HANDLE_VALUE)
		return;
	WriteFile(bmp,&bmphead,sizeof(BITMAPFILEHEADER),&temp,0);
	WriteFile(bmp,&bmpinfohead,sizeof(BITMAPINFOHEADER),&temp,0);
	WriteFile(bmp,bits,size,&temp,0);

	CloseHandle(bmp);
	GlobalUnlock(bits_mem);
	GlobalFree(bits_mem);
	SetCursor(LoadCursor(NULL,IDC_ARROW));
}

//////////////////////////////////////////////////////////
//      
//////////////////////////////////////////////////////////
void SaveBitmapFromArray(char *file, DWORD **Img, DWORD MaxX, DWORD MaxY)
{
	HANDLE				bmp;	
	BITMAPFILEHEADER	bmphead;
	BITMAPINFO			bmpinfo;
	BITMAPINFOHEADER	bmpinfohead;
	DWORD				col;
	HGLOBAL				bits_mem;
	static BYTE			*bits;
	static int			w,x,y,xm,ym;
	DWORD				size;

	xm=w=MaxX; ym=MaxY;
	(w*3)%4==0?temp1=0:temp1=4-(w*3)%4;	
	size=(xm*3+temp1)*ym;
	bits_mem=GlobalAlloc(0,size);
	if (bits_mem==NULL)
	{
		DANGMESSAGE(" !!!");
		return;
	}
	bits=(BYTE*)GlobalLock(bits_mem);
	y=ym-1; x=0;
	while (y>=0)
	{
		while (x<xm)
		{
			col=Img[x][y];
			bits[x*3+(ym-1-y)*xm*3+temp1*(ym-1-y)]=(col&0xff0000)>>16;
			bits[x*3+(ym-1-y)*xm*3+1+temp1*(ym-1-y)]=(col&0xff00)>>8;
			bits[x*3+(ym-1-y)*xm*3+2+temp1*(ym-1-y)]=(col&0xff);
			x++;
		}
		for (temp=0; temp<temp1; temp++)
			bits[3*x+(ym-1-y)*xm*3+temp1*(ym-1-y)+temp]=0;
		y--; x=0;
	}

	bmphead.bfType=0x4D42;
	bmphead.bfSize=size+54;
	bmphead.bfReserved1=bmphead.bfReserved2=0;
	bmphead.bfOffBits=54;
	bmpinfohead.biSize=sizeof(BITMAPINFOHEADER);
	bmpinfohead.biWidth=xm;
	bmpinfohead.biHeight=ym;
	bmpinfohead.biPlanes=1;
	bmpinfohead.biBitCount=24;
	bmpinfohead.biCompression=BI_RGB;
	bmpinfohead.biSizeImage=size;
	bmpinfohead.biXPelsPerMeter=bmpinfohead.biYPelsPerMeter=0;
	bmpinfohead.biClrUsed=0;
	bmpinfohead.biClrImportant=0;
	bmpinfo.bmiHeader=bmpinfohead;
	bmp=CreateFile(file,GENERIC_WRITE,0,0,CREATE_ALWAYS,0,0);
	if (bmp==INVALID_HANDLE_VALUE)
		return;
	WriteFile(bmp,&bmphead,sizeof(BITMAPFILEHEADER),&temp,0);
	WriteFile(bmp,&bmpinfohead,sizeof(BITMAPINFOHEADER),&temp,0);
	WriteFile(bmp,bits,size,&temp,0);

	CloseHandle(bmp);
	GlobalUnlock(bits_mem);
	GlobalFree(bits_mem);
	SetCursor(LoadCursor(NULL,IDC_ARROW));
}

#endif