// Misc.h
// Different service routines for RC1 interface
// (c) by 3LblDHb [Team 16]

#ifndef __misc_h
#define __misc_h


#define DOWN	TRUE
#define UP		FALSE
/////////////////////////////////////////////////////////////
//         
//////////////////////////////////////////////////////////////
void DrawListDialogIcons(HWND hDlg)
{
	SendMessage(GetDlgItem(hDlg,IDL_ADDNODE),BM_SETIMAGE,IMAGE_BITMAP,(LPARAM)LoadBitmap(_hInst,"PLUS"));
	SendMessage(GetDlgItem(hDlg,IDL_REMOVENODE),BM_SETIMAGE,IMAGE_BITMAP,(LPARAM)LoadBitmap(_hInst,"MINUS"));
	SendMessage(GetDlgItem(hDlg,IDL_OPTIONS),BM_SETIMAGE,IMAGE_BITMAP,(LPARAM)LoadBitmap(_hInst,"PROP_GRAY"));
	SendMessage(GetDlgItem(hDlg,IDL_WORK),BM_SETIMAGE,IMAGE_BITMAP,(LPARAM)LoadBitmap(_hInst,"MARK"));
	SendMessage(GetDlgItem(hDlg,IDL_LISTWRK),BM_SETIMAGE,IMAGE_BITMAP,(LPARAM)LoadBitmap(_hInst,"LIST_GRAY"));
}
////////////////////////////////////////////////////////////
//      
//	ret=>0   
//	ret<0	     
////////////////////////////////////////////////////////////
WORD GetCharPos(char *src_str,BYTE sym, bool direction)
{
	WORD	sel=lstrlen(src_str);
	WORD	rv=0;
	__asm
	{
		mov		edi,dword ptr src_str
		mov     esi, edi
		xor     ecx, ecx
		mov		cx,word ptr sel
		mov		al,sym
		
		cmp		direction,0
		je		up
		std
		add		edi,ecx
		jmp		start
up:
		cld
start:
		repne	scasb
		jne		end
		sub		edi,esi
		cmp		direction,0
		je		up_dir
		inc		edi
		mov		rv,edi
		jmp		exit_
up_dir:
		dec		edi
		mov		rv,edi
		jmp		exit_
end:
		xor		edi,edi
		dec		edi
		mov		rv,edi
exit_:
	}
	return  rv;
}
////////////////////////////////////////////////////////////
//        
////////////////////////////////////////////////////////////
char *ExtractFName(char *string)
{
/*	int		dot_off,slash_off;
	int		nlen;
	char	*rv;
	for (int ps=lstrlen(string); ps>=0; ps--)
	{
		if (string[ps]=='.')
			dot_off=ps;
		else if(string[ps]=='\\')
			break;
	}		
	
	nlen=dot_off-ps-1;
	slash_off=ps;
	rv=new char[nlen+1];
	for (ps=0; ps<nlen; ps++)
		rv[ps]=string[slash_off+ps+1];
	rv[ps]=0;
	return rv; */

	int		dot_off,slash_off;
	int		nlen;
	char	*rv;

	slash_off=GetCharPos(string,'\\',DOWN);
	dot_off=GetCharPos(string,'.',DOWN);

	nlen=dot_off-slash_off-1;
	rv=new char[nlen+1];
	for (int ps=0; ps<nlen; ps++)
		rv[ps]=string[slash_off+ps+1];
	rv[ps]=0;
	return rv;
}
////////////////////////////////////////////////////////////
//      
//	tree    -   ( !)
//	pitem   -    ,    
//	initdir -     
////////////////////////////////////////////////////////////
void RecursFindDir(HWND tree, HTREEITEM pitem, char *initdir)
{
	HANDLE			fnd;
	TV_INSERTSTRUCT	ss;
	WIN32_FIND_DATA fd;
	HTREEITEM		item;
	char			nid[255];			

	ss.hParent=pitem;
	ss.hInsertAfter=TVI_FIRST;
	ss.item.mask=TVIF_TEXT;
	fnd=FindFirstFile(initdir,&fd);
	if (fnd!=INVALID_HANDLE_VALUE)
	{
		if ((fd.dwFileAttributes>15)&&(fd.dwFileAttributes<18)&&(fd.cFileName[0]!='.'))
		{
			ss.item.pszText=fd.cFileName;
			item=TreeView_InsertItem(tree,&ss);
			lstrcpy(nid,initdir);
			nid[lstrlen(nid)-3]=0;
			lstrcat(nid,lstrcat(fd.cFileName,"\\*.*"));
			RecursFindDir(tree,item,nid);
			TreeView_SortChildren(tree,pitem,0);
		}
		while (FindNextFile(fnd,&fd))
		{
			if ((fd.dwFileAttributes>=16)&&(fd.dwFileAttributes<=17)&&(fd.cFileName[0]!='.'))
			{
/*				ss.hParent=pitem;
				ss.hInsertAfter=TVI_FIRST;
				ss.item.mask=TVIF_TEXT;*/
				ss.item.pszText=fd.cFileName;
				item=TreeView_InsertItem(tree,&ss);
				lstrcpy(nid,initdir);
				nid[lstrlen(nid)-3]=0;
				lstrcat(nid,lstrcat(fd.cFileName,"\\*.*"));
				RecursFindDir(tree,item,nid);
				TreeView_SortChildren(tree,pitem,0);
			}
		}
	}
	FindClose(fnd);
}
////////////////////////////////////////////////////////////
//       
////////////////////////////////////////////////////////////
char *RecursRootWalk(HWND tree, HTREEITEM leaf)
{
	static char	path[255];
	char		name[100];
	TV_ITEM		item;
	bool		first=true;
	
	if (first) { path[0]=0; first^=1; }
	if (leaf!=NULL)
	{
		RecursRootWalk(tree,TreeView_GetParent(tree,leaf));
		item.hItem=leaf;
		item.mask=TVIF_TEXT;
		item.pszText=name;
		item.cchTextMax=100;
		TreeView_GetItem(tree,&item);
		lstrcat(path,lstrcat(name,"\\"));
		return path;
	} else return 0;
}
////////////////////////////////////////////////////////////
//       DESTFUNC
////////////////////////////////////////////////////////////
void FindFiles(char *file, DWORD flags, HWND targ, void (*DESTFUNC)(HWND,char*))
{
	HANDLE			fnd;
	WIN32_FIND_DATA fd;
	char			fn[255];

	fnd=FindFirstFile(file,&fd);
	if (fnd!=INVALID_HANDLE_VALUE)
	{
		if (fd.dwFileAttributes==flags)
		{
			lstrcpy(fn,file);
			fn[GetCharPos(fn,'\\',DOWN)+1]=0;
			lstrcat(fn,fd.cFileName);
			DESTFUNC(targ,fn);
		}
		while (FindNextFile(fnd,&fd))
		{
			if (fd.dwFileAttributes==flags)
			{
				lstrcpy(fn,file);
				fn[GetCharPos(fn,'\\',DOWN)+1]=0;
				lstrcat(fn,fd.cFileName);
				DESTFUNC(targ,fn);
			}
		}
	}
	FindClose(fnd);
}
////////////////////////////////////////////////////////////
//   ,   
////////////////////////////////////////////////////////////
#include "direct.h"
void FillDrives(HWND tree)
{
	int				cdrv=_getdrive();
	TV_INSERTSTRUCT	ss;
	HTREEITEM		item;
	int				drive=3;

	ss.hParent=TVI_ROOT;
	ss.hInsertAfter=TVI_LAST;
	ss.item.mask=TVIF_TEXT;
	for (drive=3; drive<=26; drive++)
	{
		if (!_chdrive(drive))
		{
			char drv[5];
			drv[0]=drive+'A'-1; drv[1]=0; 
			lstrcat(drv,":\\");
			if (GetDriveType(drv)==DRIVE_FIXED)
			{
				drv[1]=':'; drv[2]=0;
				ss.item.pszText=drv;
				item=TreeView_InsertItem(tree,&ss);
				RecursFindDir(tree,item,lstrcat(drv,"\\*.*"));
			}
		}
	}
	_chdrive(cdrv);
}
//////////////////////////////////////////////////////
//     
//////////////////////////////////////////////////////
char *StrUpr(char *s_str)
{
	int   slen=lstrlen(s_str);
	__asm
	{
		xor		ecx,ecx
		xor		eax,eax
		xor		edx,edx

		mov		ebx,s_str
		mov		ecx,slen

loop_start:
		mov		dl,[ebx]

		cmp		dl,224
		jb		eng
		cmp		dl,255
		ja		limit
		jmp		trans
eng:
		cmp		dl,97
		jb		limit
		cmp		dl,122
		ja		let_e
trans:
		sub		dl,32
		mov		[ebx],dl
let_e:
		cmp		dl,184
		jne		limit
		sub		dl,16
		mov		[ebx],dl
limit:
		inc		ebx
		loop	loop_start;
	}
	return s_str;
} 
#endif
