//	Palette.h
//	Palette procedures for RC1
//	version 2.0 [02.06.2000]
//	Copyright by SkyLord [Team 16]

#ifndef __Palette_h
#define __Palette_h

#include "DynArray.h"
///////////////////////////////////////////////////////////
class ColorPalette
{
public:
	DwordArray Colors;
	DwordArray Pointers;
	ColorPalette() {_Position=0;}
	~ColorPalette() {Colors.~DwordArray(); Pointers.~DwordArray();}
   DWORD _Position;
	long Find(DWORD Color);
	DWORD Add(DWORD Color, DWORD Position);
	DWORD AddIf(DWORD Color);
	DWORD Size() {return _Position;};
};
///////////////////////////////////////////////////////////
//   X:
//   X>=0 -    ,  X
//   X<0  -     ,   
//             [-(X+1)]
///////////////////////////////////////////////////////////
long ColorPalette::Find(DWORD Color)
{
	if(_Position==0) return -1;

	DWORD tmp, LeftRange=0, RightRange=_Position-1;
   DWORD *pt1=Colors.Data;
   DWORD *pt2=Pointers.Data;

	__asm
   {
   	mov eax, pt1
// eax = pointer to Colors.Data
   	mov ebx, pt2
// ebx = pointer to Pointers.Data
Find_While:
   	mov edx, LeftRange
      cmp edx, RightRange
      je Find_Eq
// if(LeftRange==RightRange) jump Find_Eq
		add edx, RightRange
      shr edx, 1
// edx = tmpMed = (LeftRange+RightRange)/2
      mov ecx, dword ptr [ebx+4*edx]
      mov ecx, dword ptr [eax+4*ecx]
// ecx = Colors.Data[Pointers.Data[tmpMed]]
      cmp ecx, Color
      jae Find_AboveEq
// if(Colors.Data[Pointers.Data[tmpMed]]>=Color) jump Find_AboveEq
      inc edx
      mov LeftRange, edx
// LeftRange = tmpMed+1
      jmp Find_While
Find_AboveEq:
      mov RightRange, edx
// RightRange = tmpMed
      jmp Find_While
Find_Eq:
		mov edx, RightRange
      mov ecx, dword ptr [ebx+4*edx]
      mov ecx, dword ptr [eax+4*ecx]
// ecx = Colors.Data[Pointers.Data[RightRange]]
      cmp ecx, Color
      ja Find_Above
// if(Colors.Data[Pointers.Data[RightRange]]>Color) jump Find_Above
      jb Find_Below
// if(Colors.Data[Pointers.Data[RightRange]]<Color) jump Find_Below
      mov ecx, dword ptr [ebx+4*edx]
      mov tmp, ecx
// tmp=Pointers.Data[RightRange]]
	   jmp Find_End
Find_Above:
		mov eax, RightRange
      neg eax
      dec eax
      mov tmp, eax
// tmp=-RightRange-1
	   jmp Find_End
Find_Below:
		mov eax, RightRange
      neg eax
      sub eax, 2
// tmp=-RightRange-2
      mov tmp, eax
Find_End:
   }
   return tmp;
}
///////////////////////////////////////////////////////////
DWORD ColorPalette::Add(DWORD Color, DWORD Position)
{
	if(_Position>0)
   {
		Pointers[_Position+1]=Pointers[_Position-1];
		Pointers[_Position]=Pointers[_Position-1];
		for(DWORD tmp=_Position-1; tmp>Position; tmp--) Pointers/*.Data*/[tmp]=Pointers/*.Data*/[tmp-1];
   }
	Colors[_Position]=Color;
	Pointers[Position]=_Position;
   _Position++;
	return _Position-1;
}
///////////////////////////////////////////////////////////
DWORD ColorPalette::AddIf(DWORD Color)
{
	long tmp=Find(Color);
	if(tmp>=0)
		return tmp;
	else
		return Add(Color, -tmp-1);
}
///////////////////////////////////////////////////////////

#endif

