// RC1.cpp								
// RC1 Application main file
// Copyright by 3LblDEHb [Team 16]

#include <windows.h>
#include <commctrl.h>
#include "resource.h"
#include "sherror.h"

DWORD	mbinfo=MB_OK|MB_ICONASTERISK;
DWORD	mbwarn=MB_OK|MB_ICONWARNING;
DWORD	mbdang=MB_OK|MB_ICONSTOP;
#define INFOMESSAGE(mes) MessageBox(0,mes,"RC1 Image Codec",mbinfo) 
#define WARNMESSAGE(mes) MessageBox(0,mes,"RC1 Image Codec",mbwarn)
#define DANGMESSAGE(mes) MessageBox(0,mes,"RC1 Image Codec",mbdang) 

#define WM_RC_REDRAW	10000
#define WM_RC_PREVSIZE	10001

int					sets[6][32000];
static HDC			hDC, hCompDC, hmDC, hcDC, hprDC;  
static HANDLE		tbitmap;

#include "RCImage.h"
#include "Settings.h"

// compilation variants
#define _GENEREATESET					// generate "settings" in ini
#define _GENERATEPOS					//  --//--  "position" in ini
#define _TESTING_SPACE					// create testing space 

HINSTANCE			_hInst;
HWND				_hWnd,_Save;
static HWND			pre_wnd;
static HWND			codec_wnd;
static HWND			dialog___;
static HWND			list_wnd;
// Program-wide flags //////////////////
BOOL				IsOpen=FALSE;
BOOL				IsIntray=FALSE;
BOOL				IsFromList=FALSE;
BOOL				IsDoscroll=FALSE;
BOOL				IsCanceld=FALSE;
BOOL				IsPrevEnable=FALSE;
BOOL				IsSelecting=FALSE;
BOOL				IsLoaded=FALSE;
BOOL				IsFirst=TRUE;
BOOL				IsDragging=FALSE;
/////////////////////////////////////////
static DWORD		temp,temp1;
static HANDLE		hbitmap,holdbitmap,p_rect;
static char			ctemp[255];			
char				stdir[300];
RECT				rc;
BITMAP				bitmap;
SETTINGSTRUCT		ss_for_list;
int					HSize,VSize;
DWORD				px=0,py=0;

#include "Bitmap.h"
#include "Misc.h"
#include "ComDlg.h"
#include "Tray.h"
#include "List.h"

static POINT	pt2,s_pt;

void ProgressOnScreen(DWORD p1, DWORD p2)
{
	SendMessage(GetDlgItem(dialog___,IDP_PROGRESS),PBM_SETPOS,p1*100/p2,0);
	return;
}	

void ProgressInTray(DWORD p1,DWORD p2)
{
	char m_buf[100];
	char p_buf[5];
	m_buf[0]=0;
	itoa(p1*100/p2,p_buf,10);
	lstrcat(m_buf,p_buf); lstrcat(m_buf, "%");
	SetWindowText(dialog___,m_buf);
	return;
}

BOOL CALLBACK CodecDlgProc( HWND hDlg,UINT Mes,WPARAM wPar, LPARAM lPar);

BOOL CALLBACK PreviewDlgProc( HWND hDlg,UINT Mes,WPARAM wPar, LPARAM lPar)
{
	int			x,y;

	switch (Mes)
	{
	case WM_INITDIALOG:
		SetWindowPos(hDlg,HWND_TOP,0,0,HSize,VSize,0);
		hmDC=GetDC(hDlg);
		hcDC=CreateCompatibleDC(hmDC);
		hprDC=CreateCompatibleDC(hmDC);			
		p_rect=CreateCompatibleBitmap(hDC,HSize+1,VSize+1);
		SelectObject(hprDC,p_rect);
		tbitmap=CreateCompatibleBitmap(hmDC,HSize,VSize);
		SelectObject(hcDC,tbitmap);
		return TRUE;
	case WM_RC_PREVSIZE:
		DeleteObject(tbitmap);
		tbitmap=CreateCompatibleBitmap(hmDC,HSize,VSize);
		SelectObject(hcDC,tbitmap);
		DeleteObject(p_rect);
		p_rect=CreateCompatibleBitmap(hDC,HSize+1,VSize+1);
		SelectObject(hprDC,p_rect);
		break;
	case WM_RC_REDRAW:
		{
			RCImage	prev(HSize,VSize,NULL);
			for (x=0; x<HSize; x++)
				for (y=0; y<VSize; y++)
					prev.Image[x][y]=GetPixel(hCompDC,px+x,py+y);

			prev.VDiff[0]=(1<<SendMessage(GetDlgItem((void*)wPar,IDS_BPR),TBM_GETPOS,0,0))-1;
			prev.VDiff[1]=(1<<SendMessage(GetDlgItem((void*)wPar,IDS_BPG),TBM_GETPOS,0,0))-1;		
			prev.VDiff[2]=(1<<SendMessage(GetDlgItem((void*)wPar,IDS_BPB),TBM_GETPOS,0,0))-1;		
			prev.VDiff[3]=255;					
			prev.Tolerance=SendMessage(GetDlgItem((void*)wPar,IDS_FEELING),TBM_GETPOS,0,0);			
			prev.QBluring=SendMessage(GetDlgItem((void*)wPar,IDS_SMOOTH),TBM_GETPOS,0,0);			
			prev.SimulateSave();	
			for (x=0; x<HSize; x++)
				for (y=0; y<VSize; y++)
					SetPixel(hcDC,x,y,prev.Image[x][y]); 
			IsLoaded=TRUE;
			InvalidateRect(hDlg,NULL,FALSE);
		} break;
	case WM_PAINT:
		if (IsLoaded)
			BitBlt(hmDC,0,0,HSize,VSize,hcDC,0,0,SRCCOPY);
		break;
	}
	return FALSE;
}

BOOL CALLBACK DirDlgProc( HWND hDlg,UINT Mes,WPARAM wPar, LPARAM lPar)
{

	WNDINFO			wp={0,0,0,0,0};
	switch (Mes)		
	{
	case WM_INITDIALOG:
		wp=RetrWindowPos(WND_DIRLIST);
		SetWindowPos(hDlg,HWND_TOP,wp.cx,wp.cy,0,0,SWP_NOSIZE);
		FillDrives(GetDlgItem(hDlg,IDD_TREE));
		return TRUE;
	case WM_COMMAND:
		switch(LOWORD(wPar))
		{
		case IDS_OK:
			lstrcpy(ctemp,RecursRootWalk(GetDlgItem(hDlg,IDD_TREE),TreeView_GetSelection(GetDlgItem(hDlg,IDD_TREE))));
			SaveWindowPos(GetWindowInfo(hDlg),WND_DIRLIST);
			EndDialog(hDlg,0);
			break;
		case IDS_CANCEL:
			SaveWindowPos(GetWindowInfo(hDlg),WND_DIRLIST);
			EndDialog(hDlg,0);
		}
		break;
	case WM_SYSCOMMAND:
		switch (wPar)
		{
		case SC_CLOSE:
			SaveWindowPos(GetWindowInfo(hDlg),WND_DIRLIST);	
			EndDialog(hDlg,0);
			return TRUE;		
		}
	}
	return FALSE;
}

BOOL CALLBACK InterfaceDlgProc( HWND hDlg,UINT Mes,WPARAM wPar, LPARAM lPar)
{
	WNDINFO			wp={0,0,0,0,0};
	SETTINGSTRUCT	set;
	switch (Mes)
	{
	case WM_INITDIALOG:
		wp=RetrWindowPos(WND_SETUP_INTERFACE);
		SetWindowPos(hDlg,HWND_TOP,wp.cx,wp.cy,0,0,SWP_NOSIZE);
		set=GetSettings();
		SendMessage(GetDlgItem(hDlg,IDS_TRAY),BM_SETCHECK,LPARAM(set.tray),0);
		SendMessage(GetDlgItem(hDlg,IDS_TRAY_ON_CODE),BM_SETCHECK,LPARAM(set.tray_on_code),0);
		SendMessage(GetDlgItem(hDlg,IDS_PROMT),BM_SETCHECK,LPARAM(set.promt),0);
		return TRUE;
	case WM_COMMAND:
		switch(LOWORD(wPar))
		{
		case IDS_OK:
			set=GetSettings();
			set.tray=SendMessage(GetDlgItem(hDlg,IDS_TRAY),BM_GETCHECK,0,0);
			set.tray_on_code=SendMessage(GetDlgItem(hDlg,IDS_TRAY_ON_CODE),BM_GETCHECK,0,0);
			set.promt=SendMessage(GetDlgItem(hDlg,IDS_PROMT),BM_GETCHECK,0,0);
			SetSettings(&set);
			SaveWindowPos(GetWindowInfo(hDlg),WND_SETUP_INTERFACE);
			EndDialog(hDlg,0);
			break;
		case IDS_CANCEL:
			SaveWindowPos(GetWindowInfo(hDlg),WND_SETUP_INTERFACE);
			EndDialog(hDlg,0);
			break;
		} break;
	case WM_SYSCOMMAND:  
		switch (wPar)
		{
		case SC_CLOSE:
			SaveWindowPos(GetWindowInfo(hDlg),WND_SETUP_INTERFACE);	
			EndDialog(hDlg,0);
			return TRUE;		
		}
	}
	return FALSE;
}

BOOL CALLBACK SaveDlgProc( HWND hDlg,UINT Mes,WPARAM wPar, LPARAM lPar)
{
	switch (Mes)		
	{
	case WM_INITDIALOG:
		dialog___=hDlg;
		return TRUE;
	}
	return FALSE;
}

BOOL CALLBACK ListDlgProc( HWND hDlg,UINT Mes,WPARAM wPar, LPARAM lPar)
{
	WNDINFO				wp={0,0,0,0,0};
	int					pos=0,n,col,a;
	bool				flg=true;
	char				bufer[255];
	static int			i_num;
	DWORD				bsize=255;
	HMENU				popup;
	RECT				r;
	SETTINGSTRUCT		set;

	switch(Mes)
	{
	case WM_INITDIALOG:
		wp=RetrWindowPos(WND_LIST);
		SetWindowPos(hDlg,HWND_TOP,wp.cx,wp.cy,0,0,SWP_NOSIZE);
		DrawListDialogIcons(hDlg);
		GetTempPath(bsize,bufer);
		lstrcat(bufer,"\\tmp.lst");
		lstrcpy(files,bufer);
		bufer[0]=0;
		i_num=FillListFromFile(GetDlgItem(hDlg,IDL_FILELIST),files);
		return TRUE;
	case WM_COMMAND: 
		switch (LOWORD(wPar))
		{	
		case IDL_ADDNODE:
			GetWindowRect(GetDlgItem(hDlg,IDL_ADDNODE),&r);
			popup=CreatePopupMenu();
			AppendMenu(popup,MF_ENABLED|MF_STRING,IDL_ADDFILE," ");
			AppendMenu(popup,MF_ENABLED|MF_STRING,IDL_ADDDIR," ");
			TrackPopupMenuEx(popup,TPM_LEFTALIGN|TPM_TOPALIGN|TPM_LEFTBUTTON|TPM_RIGHTBUTTON,r.left,r.top+(r.bottom-r.top),hDlg,0);
			for (a=0; a<2; a++)
				DeleteMenu(popup,a,MF_BYPOSITION);
			break;
		case IDL_ADDFILE:
			ClearFilter();
			AddFilter("   RC1 (*.rc1)","*.rc1");
			AddFilter("   BMP (*.bmp)","*.bmp");
			AddFilter("  (*.lst)","*.lst");
			AddFilter("  (*.rc1;*.bmp;*.lst)","*.rc1;*.bmp;*.lst"); 
			AddFilter("  (*.*)","*.*");
			if (!GetFileName(OPEN,hDlg," ",0,1))
				return FALSE;
			i_num+=FillList(GetDlgItem(hDlg,IDL_FILELIST),files);
			set=GetSettings();
			for (a=0; a<i_num; a++)
			{
				if (sets[5][a]!=a)
				{
					sets[0][a]=set.feeling;
					sets[1][a]=set.smooth;
					sets[2][a]=set.bpr;
					sets[3][a]=set.bpg;
					sets[4][a]=set.bpb;
					sets[5][a]=a;
				}
			}
			return TRUE;
		case IDL_ADDDIR:
		{
			DialogBox(_hInst,"DIRSELECT",0,(DLGPROC)DirDlgProc);
			n=SendMessage(GetDlgItem(hDlg,IDL_FILELIST),LB_GETCOUNT,0,0);
			if (ctemp[0]!=NULL)
			{
				char ptmp[255];
				ptmp[0]=0;
				lstrcpy(ptmp,ctemp);
				FindFiles(lstrcat(ptmp,"*.rc1"),FILE_ATTRIBUTE_ARCHIVE,GetDlgItem(hDlg,IDL_FILELIST),AddToList);
				ptmp[0]=0;
				lstrcpy(ptmp,ctemp);
				FindFiles(lstrcat(ptmp,"*.bmp"),FILE_ATTRIBUTE_ARCHIVE,GetDlgItem(hDlg,IDL_FILELIST),AddToList);
				ptmp[0]=0;
				lstrcpy(ptmp,ctemp);
				FindFiles(lstrcat(ptmp,"*.lst"),FILE_ATTRIBUTE_ARCHIVE,GetDlgItem(hDlg,IDL_FILELIST),AddList);
			}
			i_num=SendMessage(GetDlgItem(hDlg,IDL_FILELIST),LB_GETCOUNT,0,0);
			set=GetSettings();
			for (a=n; a<i_num; a++)
			{
					sets[0][a]=set.feeling;
					sets[1][a]=set.smooth;
					sets[2][a]=set.bpr;
					sets[3][a]=set.bpg;
					sets[4][a]=set.bpb;
					sets[5][a]=a;
			}
			break;
		}
		case IDL_REMOVENODE:
			GetWindowRect(GetDlgItem(hDlg,IDL_REMOVENODE),&r);
			popup=CreatePopupMenu();
			AppendMenu(popup,MF_ENABLED|MF_STRING,IDL_REMOVESEL," ");
			AppendMenu(popup,MF_ENABLED|MF_STRING,IDL_REMOVEALL," ");
			TrackPopupMenuEx(popup,TPM_LEFTALIGN|TPM_TOPALIGN|TPM_LEFTBUTTON|TPM_RIGHTBUTTON,r.left,r.top+(r.bottom-r.top),hDlg,0);
			for (a=0; a<2; a++)
				DeleteMenu(popup,a,MF_BYPOSITION);
			break;
		case IDL_REMOVESEL:
			col=SendMessage(GetDlgItem(hDlg,IDL_FILELIST),LB_GETCOUNT,0,0);
			i_num-=col;
			temp=0;
			while (temp<col)
			{
				if (SendMessage(GetDlgItem(hDlg,IDL_FILELIST),LB_GETSEL,temp,0))
				{
					col=SendMessage(GetDlgItem(hDlg,IDL_FILELIST),LB_DELETESTRING,temp,0)+1;
					temp=0;
				} else
				temp++;
			}
			break;
		case IDL_REMOVEALL:
			SendMessage(GetDlgItem(hDlg,IDL_FILELIST),LB_RESETCONTENT,0,0);
			break;
		case IDL_LISTWRK:
			GetWindowRect(GetDlgItem(hDlg,IDL_LISTWRK),&r);
			popup=CreatePopupMenu();
			AppendMenu(popup,MF_ENABLED|MF_STRING,IDL_SAVELIST," ");
			AppendMenu(popup,MF_ENABLED|MF_STRING,IDL_LOADLIST," ");
			TrackPopupMenuEx(popup,TPM_LEFTALIGN|TPM_TOPALIGN|TPM_LEFTBUTTON|TPM_RIGHTBUTTON,r.left,r.top+(r.bottom-r.top),hDlg,0);
			for (a=0; a<2; a++)
				DeleteMenu(popup,a,MF_BYPOSITION);
			break;
		case IDL_SAVELIST:
			ClearFilter();
			AddFilter("  (*.lst)","*.lst");
			if (!GetFileName(SAVE,_hWnd,"  ",1,0,"lst"))
				return FALSE;	
			SaveListToFile(GetDlgItem(hDlg,IDL_FILELIST),files);
			break;
		case IDL_LOADLIST:
			SendMessage(GetDlgItem(hDlg,IDL_FILELIST),LB_RESETCONTENT,0,0);
			ClearFilter();
			AddFilter("  (*.lst)","*.lst");
			if (!GetFileName(OPEN,_hWnd,"  ",0,0))
				return FALSE;
			i_num=FillListFromFile(GetDlgItem(hDlg,IDL_FILELIST),files);
			break;
		case IDS_OK:
			SaveWindowPos(GetWindowInfo(hDlg),WND_LIST);
			GetTempPath(bsize,bufer);
			lstrcat(bufer,"\\tmp.lst");
			lstrcpy(files,bufer);
			bufer[0]=0;
			SaveListToFile(GetDlgItem(hDlg,IDL_FILELIST),files);
			EndDialog(hDlg,0);
			break;
		case IDL_WORK:
		{
			HWND	savedlg;
			int		okc=0;
			char	ret[4];
			n=SendMessage(GetDlgItem(hDlg,IDL_FILELIST),LB_GETCOUNT,0,0);
			if (n>0)
			{
				savedlg=CreateDialog(_hInst,"SAVE",hDlg,(DLGPROC)SaveDlgProc);
				ShowWindow(savedlg,SW_SHOWNORMAL);
				UpdateWindow(savedlg);
				SetWindowText(GetDlgItem(savedlg,IDP_ALL),itoa(n,ret,10));
				for(pos=0; pos<n; pos++)
				{
					SendMessage(GetDlgItem(hDlg,IDL_FILELIST),LB_GETTEXT,(WPARAM)pos,(LPARAM)files);
					SetWindowText(GetDlgItem(savedlg,IDP_CURRENT),files);
					switch (GetCurrentFileType(files))
					{
					case FT_BITMAP:
					{
						if (IsOpen)
							holdbitmap=SelectObject(hCompDC,hbitmap);
						hbitmap=LoadImage(NULL,files,IMAGE_BITMAP,0,0,LR_LOADFROMFILE);
						int aaa=GetCharPos(files,'.',DOWN);
						files[GetCharPos(files,'.',DOWN)]=0;
						lstrcat(files,".rc1");
						SelectObject(hCompDC,hbitmap);
						GetObject(hbitmap,sizeof(BITMAP),&bitmap);
						SETTINGSTRUCT c_set=GetSettings();
						RCImage tst(bitmap.bmWidth-1, bitmap.bmHeight-1,NULL);
						if (c_set.tray_on_code)
						{
							ShowWindow(list_wnd,SW_HIDE);
							ShowWindow(_hWnd,SW_HIDE);
							ShowWindow(savedlg,SW_MINIMIZE);
							tst.ProgressFunctor=ProgressInTray;
						}
						else
						{
							tst.ProgressFunctor=ProgressOnScreen;
						}
						for (temp=0; temp<tst.MaxXCoord; temp++)
							for (temp1=0; temp1<tst.MaxYCoord; temp1++)
								tst.Image[temp][temp1]=GetPixel(hCompDC,temp,temp1);
						tst.VDiff[0]=(1<<sets[2][pos])-1;		//MaxDifferentTones for Red
						tst.VDiff[1]=(1<<sets[3][pos])-1;		//MaxDifferentTones for Green
						tst.VDiff[2]=(1<<sets[4][pos])-1;		//MaxDifferentTones for Blue
						tst.VDiff[3]=255;					//MaxDifferentTones for Alpha
						tst.Tolerance=sets[0][pos];			//Quality of saving
						tst.QBluring=sets[1][pos];			//Quality of bluring
						char msg_buf[500];
						if ((!c_set.promt)&&(IsFileExist(files)))
						{ 
							msg_buf[0]=0;
							lstrcat(msg_buf," "); lstrcat(msg_buf, files); lstrcat(msg_buf, " ,  ?");
							if (MessageBox(0,msg_buf,"RC1 Image Codec",MB_YESNO|MB_ICONQUESTION)==IDYES)
								tst.SaveImage(files);						
						} else tst.SaveImage(files);
						if (IsOpen)
							SelectObject(hCompDC,holdbitmap);
						okc++;
						SetWindowText(GetDlgItem(savedlg,IDP_NOERROR),itoa(okc,ret,10));	
						break;
					}
					case FT_RC1:
					{
						RCImage tst(files,NULL);
						files[GetCharPos(files,'.',DOWN)]=0;
						lstrcat(files,".bmp");
						SETTINGSTRUCT c_set=GetSettings();
						char msg_buf[500];
						msg_buf[0]=0;
						lstrcat(msg_buf," "); lstrcat(msg_buf, files); lstrcat(msg_buf, " ,  ?");
						if ((!c_set.promt)&&(IsFileExist(files)))
						{
							if (MessageBox(0,msg_buf,"RC1 Image Codec",MB_YESNO||MB_ICONQUESTION)==IDYES)
								SaveBitmapFromArray(files,tst.Image,tst.MaxXCoord,tst.MaxYCoord);
						} else SaveBitmapFromArray(files,tst.Image,tst.MaxXCoord,tst.MaxYCoord);
						okc++;
						SetWindowText(GetDlgItem(savedlg,IDP_NOERROR),itoa(okc,ret,10));	
						break;
					}
					}
				}
			} 
			DestroyWindow(savedlg);
			ShowWindow(_hWnd,SW_SHOWNORMAL);
			ShowWindow(list_wnd,SW_SHOWNORMAL);
			break;
		}
		case IDL_OPTIONS:
			IsFromList=TRUE;
			n=SendMessage(GetDlgItem(hDlg,IDL_FILELIST),LB_GETSELCOUNT,0,0);
			int *sel_items=new int[n];
			SendMessage(GetDlgItem(hDlg,IDL_FILELIST),LB_GETSELITEMS,n,(LPARAM)sel_items);
			if (n>0)
			{
				ss_for_list.feeling=sets[0][sel_items[0]];
				ss_for_list.smooth=sets[1][sel_items[0]];
				ss_for_list.bpr=sets[2][sel_items[0]];
				ss_for_list.bpg=sets[3][sel_items[0]];
				ss_for_list.bpb=sets[4][sel_items[0]];
				DialogBox(_hInst,"OPTIONS_CODEC",_hWnd,(DLGPROC)CodecDlgProc);
				if (!IsCanceld)
				{
					for (a=0; a<n; a++)
					{
						sets[0][sel_items[a]]=ss_for_list.feeling;
						sets[1][sel_items[a]]=ss_for_list.smooth;
						sets[2][sel_items[a]]=ss_for_list.bpr;
						sets[3][sel_items[a]]=ss_for_list.bpg;
						sets[4][sel_items[a]]=ss_for_list.bpb;
						sets[5][sel_items[a]]=sel_items[a];
					}
				} else IsCanceld=FALSE;
			}
			delete [] sel_items;
			break;
		} break;
	case WM_SYSCOMMAND:
		switch (wPar)
		{
		case SC_CLOSE:
			SaveWindowPos(GetWindowInfo(hDlg),WND_LIST);
			GetTempPath(bsize,bufer);
			lstrcat(bufer,"\\tmp.lst");
			lstrcpy(files,bufer);
			bufer[0]=0;
			SaveListToFile(GetDlgItem(hDlg,IDL_FILELIST),files);
			EndDialog(hDlg,0);
			return TRUE;
		}
	}
	return FALSE;
}

BOOL CALLBACK AboutDlgProc( HWND hDlg,UINT Mes,WPARAM wPar, LPARAM lPar)
{
	WNDINFO	wp={0,0,0,0,0};
	switch(Mes)
	{
	case WM_INITDIALOG:
#ifdef GENERATEPOS
		SaveWindowPos(GetWindowInfo(hDlg),WND_ABOUT);
#endif
		wp=RetrWindowPos(WND_ABOUT);
		SetWindowPos(hDlg,HWND_TOP,wp.cx,wp.cy,0,0,SWP_NOSIZE);
		return TRUE;
	case WM_COMMAND:
		switch (LOWORD(wPar))
		{
		case IDS_OK:
			SaveWindowPos(GetWindowInfo(hDlg),WND_ABOUT);	
			EndDialog(hDlg,0);
			return TRUE;
		}break;
	case WM_SYSCOMMAND:
		switch (wPar)
		{
		case SC_CLOSE:
			SaveWindowPos(GetWindowInfo(hDlg),WND_ABOUT);
			EndDialog(hDlg,0);
			return TRUE;
		} break;
	}
	return FALSE;
}

BOOL CALLBACK CodecDlgProc( HWND hDlg,UINT Mes,WPARAM wPar, LPARAM lPar)
{
	SETTINGSTRUCT			sc;
	WNDINFO					wp={0,0,0,0,0};
	int						ctlid,a;
	char					pos[4];

	switch(Mes)	
	{
	case WM_INITDIALOG:
		wp=RetrWindowPos(WND_SETUP_CODEC);
		SetWindowPos(hDlg,HWND_TOP,wp.cx,wp.cy,0,0,SWP_NOSIZE);
		IsLoaded=FALSE;
		sc=GetSettings();
		GetObject(hbitmap,sizeof(BITMAP),&bitmap);
		if (IsOpen)
		{
			sc.hs=sc.hs>bitmap.bmWidth?bitmap.bmWidth:sc.hs;
			sc.vs=sc.vs>bitmap.bmHeight?bitmap.bmHeight:sc.vs;
		} 
//////////////////// INITIALIZING RANGES /////////////////////////////////////
		SendMessage(GetDlgItem(hDlg,IDS_VERSIZE),TBM_SETRANGE,TRUE,MAKELONG(10,bitmap.bmHeight>250?250:bitmap.bmHeight));
		SendMessage(GetDlgItem(hDlg,IDS_HORSIZE),TBM_SETRANGE,TRUE,MAKELONG(10,bitmap.bmWidth>250?250:bitmap.bmWidth));
		SendMessage(GetDlgItem(hDlg,IDS_BPC),TBM_SETRANGE,TRUE,MAKELONG(0,8));
		SendMessage(GetDlgItem(hDlg,IDS_BPR),TBM_SETRANGE,TRUE,MAKELONG(0,8));
		SendMessage(GetDlgItem(hDlg,IDS_BPG),TBM_SETRANGE,TRUE,MAKELONG(0,8));
		SendMessage(GetDlgItem(hDlg,IDS_BPB),TBM_SETRANGE,TRUE,MAKELONG(0,8));
		SendMessage(GetDlgItem(hDlg,IDS_FEELING),TBM_SETRANGE,TRUE,MAKELONG(0,50));
		SendMessage(GetDlgItem(hDlg,IDS_SMOOTH),TBM_SETRANGE,TRUE,MAKELONG(0,150));
		for (a=0; a<=50; a+=5)
		{
			SendMessage(GetDlgItem(hDlg,IDS_FEELING),TBM_SETTIC,0,a);
			SendMessage(GetDlgItem(hDlg,IDS_SMOOTH),TBM_SETTIC,0,a*3);
		}
///////////////////// SETTING VALUES /////////////////////////////////////////
		if (!IsFromList)
		{
			SendMessage(GetDlgItem(hDlg,IDS_BPC),TBM_SETPOS,TRUE,sc.bpc);
			SendMessage(GetDlgItem(hDlg,IDS_BPR),TBM_SETPOS,TRUE,sc.bpr);
			SendMessage(GetDlgItem(hDlg,IDS_BPG),TBM_SETPOS,TRUE,sc.bpg);
			SendMessage(GetDlgItem(hDlg,IDS_BPB),TBM_SETPOS,TRUE,sc.bpb);
			SendMessage(GetDlgItem(hDlg,IDS_FEELING),TBM_SETPOS,TRUE,sc.feeling);
			SendMessage(GetDlgItem(hDlg,IDS_SMOOTH),TBM_SETPOS,TRUE,sc.smooth);
			SendMessage(GetDlgItem(hDlg,IDS_SAMPLE),BM_SETCHECK,LPARAM(sc.preview),0);		
			SendMessage(GetDlgItem(hDlg,IDS_VERSIZE),TBM_SETPOS,TRUE,sc.vs>bitmap.bmHeight?bitmap.bmHeight:sc.vs);
			SendMessage(GetDlgItem(hDlg,IDS_HORSIZE),TBM_SETPOS,TRUE,sc.hs>bitmap.bmWidth?bitmap.bmWidth:sc.hs);
			HSize=sc.hs; VSize=sc.vs;
			IsPrevEnable=sc.preview;
		} 
		else
		{
			SendMessage(GetDlgItem(hDlg,IDS_BPC),TBM_SETPOS,TRUE,8);
			SendMessage(GetDlgItem(hDlg,IDS_BPR),TBM_SETPOS,TRUE,ss_for_list.bpr);
			SendMessage(GetDlgItem(hDlg,IDS_BPG),TBM_SETPOS,TRUE,ss_for_list.bpg);
			SendMessage(GetDlgItem(hDlg,IDS_BPB),TBM_SETPOS,TRUE,ss_for_list.bpb);
			SendMessage(GetDlgItem(hDlg,IDS_FEELING),TBM_SETPOS,TRUE,ss_for_list.feeling);
			SendMessage(GetDlgItem(hDlg,IDS_SMOOTH),TBM_SETPOS,TRUE,ss_for_list.smooth);
		}
//////////////////// DISPLAYING VALUES /////////////////////////////////////////
		if (!IsFromList)
		{
			EnableWindow(GetDlgItem(hDlg,IDS_SAMPLE),IsOpen);	
			EnableWindow(GetDlgItem(hDlg,IDS_SELECT),IsOpen);	
			EnableWindow(GetDlgItem(hDlg,IDS_VERSIZE),IsOpen);	
			EnableWindow(GetDlgItem(hDlg,IDS_HORSIZE),IsOpen);	
			SetWindowText(GetDlgItem(hDlg,IDS_FEEL_VAL),itoa((50-sc.feeling)*2,pos,10));
			SetWindowText(GetDlgItem(hDlg,IDS_BPC_VAL),itoa(sc.bpc,pos,10));
			SetWindowText(GetDlgItem(hDlg,IDS_BPR_VAL),itoa(sc.bpr,pos,10));
			SetWindowText(GetDlgItem(hDlg,IDS_BPG_VAL),itoa(sc.bpg,pos,10));
			SetWindowText(GetDlgItem(hDlg,IDS_BPB_VAL),itoa(sc.bpb,pos,10));
			SetWindowText(GetDlgItem(hDlg,IDS_SMOOTH_VAL),itoa(sc.smooth,pos,10));
			SetWindowText(GetDlgItem(hDlg,IDS_VERVAL),itoa(sc.vs>bitmap.bmHeight?bitmap.bmHeight:sc.vs,pos,10));
			SetWindowText(GetDlgItem(hDlg,IDS_HORVAL),itoa(sc.hs>bitmap.bmWidth?bitmap.bmWidth:sc.hs,pos,10));
		} else
		{
			EnableWindow(GetDlgItem(hDlg,IDS_LOADDEF),FALSE);
			EnableWindow(GetDlgItem(hDlg,IDS_SETDEF),FALSE);
			EnableWindow(GetDlgItem(hDlg,IDS_SAMPLE),FALSE);
			EnableWindow(GetDlgItem(hDlg,IDS_PREVIEW),FALSE);
			EnableWindow(GetDlgItem(hDlg,IDS_HORSIZE),FALSE);
			EnableWindow(GetDlgItem(hDlg,IDS_VERSIZE),FALSE);
			EnableWindow(GetDlgItem(hDlg,IDS_SELECT),FALSE);
			SetWindowText(GetDlgItem(hDlg,IDS_FEEL_VAL),itoa((50-ss_for_list.feeling)*2,pos,10));
			SetWindowText(GetDlgItem(hDlg,IDS_BPC_VAL),"8");
			SetWindowText(GetDlgItem(hDlg,IDS_BPR_VAL),itoa(ss_for_list.bpr,pos,10));
			SetWindowText(GetDlgItem(hDlg,IDS_BPG_VAL),itoa(ss_for_list.bpg,pos,10));
			SetWindowText(GetDlgItem(hDlg,IDS_BPB_VAL),itoa(ss_for_list.bpb,pos,10));
			SetWindowText(GetDlgItem(hDlg,IDS_SMOOTH_VAL),itoa(ss_for_list.smooth,pos,10));
		}
//------- Creating Preview Window -------
		if ((IsOpen)&&(IsPrevEnable)&&(!IsFromList))
		{
			pre_wnd=CreateDialog(_hInst,"PREVIEW",_hWnd,(DLGPROC)PreviewDlgProc);
			ShowWindow(pre_wnd,SW_SHOWNORMAL);
			UpdateWindow(pre_wnd);
//			SendMessage(pre_wnd,WM_RC_REDRAW,(WPARAM)hDlg,0);
		}
//---------------------------------
		return TRUE; 
	case WM_VSCROLL:
		SetWindowText(GetDlgItem(hDlg,GetDlgCtrlID((VOID*)lPar)+1),itoa(VSize=SendMessage((VOID*)lPar,TBM_GETPOS,0,0),pos,10));
		SendMessage(pre_wnd,WM_RC_PREVSIZE,(WPARAM)hDlg,0);
		SetWindowPos(pre_wnd,HWND_TOP,0,0,HSize,VSize,SWP_NOMOVE);
		if (IsPrevEnable)
			SendMessage(pre_wnd,WM_RC_REDRAW,(WPARAM)hDlg,0);
		break;
	case WM_HSCROLL:
			SetWindowText(GetDlgItem(hDlg,GetDlgCtrlID((VOID*)lPar)+1),itoa(SendMessage((VOID*)lPar,TBM_GETPOS,0,0),pos,10));
			ctlid=GetDlgCtrlID((VOID*)lPar);
			if (ctlid==IDS_BPC)
			{
				int bpcpos=SendMessage(GetDlgItem(hDlg,IDS_BPC),TBM_GETPOS,0,0);
				SendMessage(GetDlgItem(hDlg,IDS_BPR),TBM_SETPOS,TRUE,bpcpos);
				SendMessage(GetDlgItem(hDlg,IDS_BPG),TBM_SETPOS,TRUE,bpcpos);
				SendMessage(GetDlgItem(hDlg,IDS_BPB),TBM_SETPOS,TRUE,bpcpos);
				SetWindowText(GetDlgItem(hDlg,IDS_BPR_VAL),itoa(bpcpos,pos,10));
				SetWindowText(GetDlgItem(hDlg,IDS_BPG_VAL),itoa(bpcpos,pos,10));
				SetWindowText(GetDlgItem(hDlg,IDS_BPB_VAL),itoa(bpcpos,pos,10));
			} else
			if (ctlid==IDS_FEELING)
			{
				int feelpos=SendMessage(GetDlgItem(hDlg,IDS_FEELING),TBM_GETPOS,0,0)*3;
				SendMessage(GetDlgItem(hDlg,IDS_SMOOTH),TBM_SETPOS,TRUE,feelpos);
				SetWindowText(GetDlgItem(hDlg,IDS_FEEL_VAL),itoa((50-feelpos/3)*2,pos,10));
				SetWindowText(GetDlgItem(hDlg,IDS_SMOOTH_VAL),itoa(feelpos,pos,10));
			} else
			if (ctlid==IDS_HORSIZE)
			{
				HSize=SendMessage((VOID*)lPar,TBM_GETPOS,0,0);
				SendMessage(pre_wnd,WM_RC_PREVSIZE,(WPARAM)hDlg,0);
				SetWindowPos(pre_wnd,HWND_TOP,0,0,HSize,VSize,0);
				if (IsPrevEnable)
					SendMessage(pre_wnd,WM_RC_REDRAW,(WPARAM)hDlg,SWP_NOMOVE);
			}
		if ((ctlid!=IDS_HORSIZE)&&(IsPrevEnable)&&(!IsFromList))
			SendMessage(pre_wnd,WM_RC_REDRAW,(WPARAM)hDlg,0);
		break;
	case WM_COMMAND:
		switch (LOWORD(wPar))
		{
		case IDS_SELECT:
			ShowWindow(hDlg,SW_HIDE);
			ShowWindow(pre_wnd,SW_HIDE);
			InvalidateRect(_hWnd,NULL,FALSE);
			IsSelecting=TRUE; 
			BringWindowToTop(_hWnd);
			break;
		case IDS_SAMPLE:
			IsPrevEnable^=1;
			if (IsPrevEnable)
			{
				ShowWindow(pre_wnd,SW_SHOWNORMAL);
				SendMessage(pre_wnd,WM_RC_REDRAW,(WPARAM)hDlg,0);

			} else
			{
				ShowWindow(pre_wnd,SW_HIDE);
				IsLoaded=FALSE;
			}
			break;
		case IDS_CANCEL:
			SaveWindowPos(GetWindowInfo(hDlg),WND_SETUP_CODEC);	
			DeleteDC(hmDC);
			DeleteDC(hcDC);
			IsCanceld=TRUE;
			EndDialog(pre_wnd,0);
			EndDialog(hDlg,0);
			DeleteObject(tbitmap);
			DeleteDC(hprDC);
			DeleteObject(p_rect);
			return TRUE;
		case IDS_SETDEF:
			sc.feeling=SendMessage(GetDlgItem(hDlg,IDS_FEELING),TBM_GETPOS,0,0);
			sc.bpc=SendMessage(GetDlgItem(hDlg,IDS_BPC),TBM_GETPOS,0,0);
			sc.bpr=SendMessage(GetDlgItem(hDlg,IDS_BPR),TBM_GETPOS,0,0);
			sc.bpg=SendMessage(GetDlgItem(hDlg,IDS_BPG),TBM_GETPOS,0,0);
			sc.bpb=SendMessage(GetDlgItem(hDlg,IDS_BPB),TBM_GETPOS,0,0);
			sc.smooth=SendMessage(GetDlgItem(hDlg,IDS_SMOOTH),TBM_GETPOS,0,0);
			sc.preview=SendMessage(GetDlgItem(hDlg,IDS_SAMPLE),BM_GETCHECK,0,0);
			sc.vs=VSize; sc.hs=HSize;
			SetDefault(&sc);
			return TRUE;
		case IDS_LOADDEF:
			sc=GetDefault();
///////////////////// SETTING VALUES //////////////////////////////////////////
			SendMessage(GetDlgItem(hDlg,IDS_BPC),TBM_SETPOS,TRUE,sc.bpc);
			SendMessage(GetDlgItem(hDlg,IDS_BPR),TBM_SETPOS,TRUE,sc.bpr);
			SendMessage(GetDlgItem(hDlg,IDS_BPG),TBM_SETPOS,TRUE,sc.bpg);
			SendMessage(GetDlgItem(hDlg,IDS_BPB),TBM_SETPOS,TRUE,sc.bpb);
			SendMessage(GetDlgItem(hDlg,IDS_FEELING),TBM_SETPOS,TRUE,sc.feeling);
			SendMessage(GetDlgItem(hDlg,IDS_SMOOTH),TBM_SETPOS,TRUE,sc.smooth);
			SendMessage(GetDlgItem(hDlg,IDS_VERSIZE),TBM_SETPOS,TRUE,sc.vs);
			SendMessage(GetDlgItem(hDlg,IDS_HORSIZE),TBM_SETPOS,TRUE,sc.hs);
			SendMessage(GetDlgItem(hDlg,IDS_SAMPLE),BM_SETCHECK,LPARAM(sc.preview),0);		
			HSize=sc.hs; VSize=sc.vs;
//////////////////// DISPLAYING VALUES /////////////////////////////////////////
			char pos[4];
			SetWindowText(GetDlgItem(hDlg,IDS_FEEL_VAL),itoa((50-sc.feeling)*2,pos,10));
			SetWindowText(GetDlgItem(hDlg,IDS_BPC_VAL),itoa(sc.bpc,pos,10));
			SetWindowText(GetDlgItem(hDlg,IDS_BPR_VAL),itoa(sc.bpr,pos,10));
			SetWindowText(GetDlgItem(hDlg,IDS_BPG_VAL),itoa(sc.bpg,pos,10));
			SetWindowText(GetDlgItem(hDlg,IDS_BPB_VAL),itoa(sc.bpb,pos,10));
			SetWindowText(GetDlgItem(hDlg,IDS_SMOOTH_VAL),itoa(sc.smooth,pos,10));
			SetWindowText(GetDlgItem(hDlg,IDS_VERVAL),itoa(sc.vs,pos,10));
			SetWindowText(GetDlgItem(hDlg,IDS_HORVAL),itoa(sc.hs,pos,10));
			return TRUE; 
		case IDS_OK:
			if (!IsFromList)
			{
				sc=GetSettings();
				sc.feeling=SendMessage(GetDlgItem(hDlg,IDS_FEELING),TBM_GETPOS,0,0);
				sc.bpc=SendMessage(GetDlgItem(hDlg,IDS_BPC),TBM_GETPOS,0,0);
				sc.bpr=SendMessage(GetDlgItem(hDlg,IDS_BPR),TBM_GETPOS,0,0);
				sc.bpg=SendMessage(GetDlgItem(hDlg,IDS_BPG),TBM_GETPOS,0,0);
				sc.bpb=SendMessage(GetDlgItem(hDlg,IDS_BPB),TBM_GETPOS,0,0);
				sc.smooth=SendMessage(GetDlgItem(hDlg,IDS_SMOOTH),TBM_GETPOS,0,0);
				sc.preview=SendMessage(GetDlgItem(hDlg,IDS_SAMPLE),BM_GETCHECK,0,0);
				sc.hs=HSize; sc.vs=VSize;
				SetSettings(&sc);
			} else
			{
				ss_for_list.feeling=SendMessage(GetDlgItem(hDlg,IDS_FEELING),TBM_GETPOS,0,0);
				ss_for_list.bpc=SendMessage(GetDlgItem(hDlg,IDS_BPC),TBM_GETPOS,0,0);
				ss_for_list.bpr=SendMessage(GetDlgItem(hDlg,IDS_BPR),TBM_GETPOS,0,0);
				ss_for_list.bpg=SendMessage(GetDlgItem(hDlg,IDS_BPG),TBM_GETPOS,0,0);
				ss_for_list.bpb=SendMessage(GetDlgItem(hDlg,IDS_BPB),TBM_GETPOS,0,0);
				ss_for_list.smooth=SendMessage(GetDlgItem(hDlg,IDS_SMOOTH),TBM_GETPOS,0,0);
			}	
			SaveWindowPos(GetWindowInfo(hDlg),WND_SETUP_CODEC);	
			DeleteDC(hmDC);
			DeleteDC(hcDC);
			DeleteDC(hprDC);
			DeleteObject(p_rect);
			DeleteObject(tbitmap);
			EndDialog(hDlg,0);
			EndDialog(pre_wnd,0);
			IsFromList=FALSE;
			return TRUE;
		}break;
	case WM_SHOWWINDOW:
		if (wPar)
		{
			if (IsPrevEnable)
			{
				ShowWindow(pre_wnd,SW_SHOWNORMAL);
				SendMessage(pre_wnd,WM_RC_REDRAW,(WPARAM)hDlg,0);
			}
		}
		break;
	case WM_SYSCOMMAND:
		switch (wPar)
		{
		case SC_CLOSE:
			SaveWindowPos(GetWindowInfo(hDlg),WND_SETUP_CODEC);	
			DeleteDC(hmDC);
			DeleteDC(hcDC);
			DeleteObject(tbitmap);
			DeleteDC(hprDC);
			DeleteObject(p_rect);
			EndDialog(pre_wnd,0);
			EndDialog(hDlg,0);
			return TRUE;		
		}
	}
	return FALSE;
}

LRESULT CALLBACK MainWndProc(HWND hwnd,UINT Mes,UINT wPar,LONG lPar)
{
	SETTINGSTRUCT	set;
	char			caption[255]={"RC1 Image Codec - "};				
	static int		HorDif=0, VerDif=0;
	static int		HorPos=0, VerPos=0;
	int mx,my;

	switch(Mes)
	{
	case WM_CREATE:
		SetScrollRange(hwnd,SB_VERT,0,0,TRUE);
		SetScrollRange(hwnd,SB_HORZ,0,0,TRUE);
		break;
	case WM_PAINT:
		if (IsOpen)
		{
			GetObject(hbitmap,sizeof(BITMAP),&bitmap);
			GetClientRect(hwnd,&rc);
			if (bitmap.bmHeight-VerPos<rc.bottom)
				VerPos-=rc.bottom-bitmap.bmHeight+VerPos;
			if (bitmap.bmWidth-HorPos<rc.right)
				HorPos-=rc.right-bitmap.bmWidth+HorPos;

			if ((HorDif=(bitmap.bmWidth-rc.right))>0)
				SetScrollRange(hwnd,SB_HORZ,0,HorDif,TRUE);
			else
				SetScrollRange(hwnd,SB_HORZ,0,0,TRUE);
			if ((VerDif=(bitmap.bmHeight-rc.bottom))>0)
				SetScrollRange(hwnd,SB_VERT,0,VerDif,TRUE);
			else
				SetScrollRange(hwnd,SB_VERT,0,0,TRUE);

			GetClientRect(hwnd,&rc);
			if (bitmap.bmHeight<rc.bottom)
				VerPos=0;
			if (bitmap.bmWidth<rc.right)
				HorPos=0; 
			my=bitmap.bmHeight<rc.bottom?bitmap.bmHeight:rc.bottom;
			mx=bitmap.bmWidth<rc.right?bitmap.bmWidth:rc.right;
			BitBlt(hDC,0,0,mx,my,hCompDC,HorPos,VerPos,SRCCOPY);
		}
		break;
	case WM_VSCROLL:
		switch(LOWORD(wPar))
		{
		case SB_LINEDOWN:
			if (VerPos<VerDif)
			{
				VerPos++; IsDoscroll=TRUE; 
			}
			break;
		case SB_LINEUP:
			if (VerPos>0)
			{
				VerPos--; IsDoscroll=TRUE;
			}
			break;
		case SB_THUMBTRACK:
			VerPos=HIWORD(wPar);
			IsDoscroll=TRUE;
			break;
		case SB_PAGEDOWN:
			if (VerPos+10<VerDif)
				VerPos+=10;
			else
				VerPos=VerDif;
			IsDoscroll=TRUE;
			break;
		case SB_PAGEUP:
			if (VerPos-10>0)
				VerPos-=10;
			else
				VerPos=0;
			IsDoscroll=TRUE;
			break;
		}
		if (IsDoscroll)
		{
			SetScrollPos(hwnd,SB_VERT,VerPos,TRUE);
			InvalidateRect(hwnd,NULL,FALSE);
			IsDoscroll=FALSE;
		}
		break;
	case WM_HSCROLL:
		switch(LOWORD(wPar))
		{
		case SB_LINEDOWN:
			if (HorPos<HorDif)
			{
				HorPos++; IsDoscroll=TRUE; 
			}
			break;
		case SB_LINEUP:
			if (HorPos>0)
			{
				HorPos--; IsDoscroll=TRUE;
			}
			break;
		case SB_THUMBTRACK:
			HorPos=HIWORD(wPar);
			IsDoscroll=TRUE;
			break;
		case SB_PAGELEFT:
			if (HorPos-10>0)
				HorPos-=10;
			else
				HorPos=0;
			IsDoscroll=TRUE;
			break;
		case SB_PAGERIGHT:
			if (HorPos+10<HorDif)
				HorPos+=10;
			else
				HorPos=HorDif;
			IsDoscroll=TRUE;
			break;
		}
		if (IsDoscroll)
		{
			SetScrollPos(hwnd,SB_HORZ,HorPos,TRUE);
			InvalidateRect(hwnd,NULL,FALSE);
			IsDoscroll=FALSE;
		}
		break;
/*	case WM_LBUTTONUP:
		if (IsSelecting)
		{
			char r[6];
			IsDragging=FALSE;
			ShowWindow(codec_wnd,SW_RESTORE);
			HSize=abs(HSize);
			VSize=abs(VSize);
			IsSelecting^=1;
		}
		break;*/
	case WM_LBUTTONDOWN:
/*		if (IsSelecting)
		{
			char	r[8];
			IsDragging=TRUE;
			s_pt.x=lPar&0xFFFF;
			s_pt.y=(lPar&0xFFFF0000)>>16;
//			INFOMESSAGE(itoa(s_pt.x,r,10));
//			INFOMESSAGE(itoa(s_pt.y,r,10));
			IsFirst=TRUE;
//			ScreenToClient(_hWnd,&s_pt);
		}*/
		if (IsSelecting)
		{
			POINT pt;
			GetCursorPos(&pt);
			BitBlt(hDC,pt2.x,pt2.y,HSize+1,VSize+1,hprDC,0,0,SRCCOPY);
			ScreenToClient(_hWnd,&pt);
			px=pt.x+HorPos; py=pt.y+VerPos;
			GetWindowRect(_hWnd,&rc);
			IsSelecting^=1;
			IsFirst=TRUE;
			ShowWindow(pre_wnd,SW_SHOWNORMAL);
			ShowWindow(codec_wnd,SW_SHOWNORMAL);
			InvalidateRect(_hWnd,NULL,FALSE);
		}
		break;
	case WM_MOUSEMOVE:
		if (IsSelecting)
		{
			POINT			pt;
			if (!IsFirst)
				BitBlt(hDC,pt2.x,pt2.y,HSize+1,VSize+1,hprDC,0,0,SRCCOPY);
			GetCursorPos(&pt);
			ScreenToClient(_hWnd,&pt);
			px=pt.x; py=pt.y;
			BitBlt(hprDC,0,0,HSize+1,VSize+1,hDC,px,py,SRCCOPY);
			MoveToEx(hDC,px,py,NULL);
			LineTo(hDC,px+HSize,py);
			LineTo(hDC,px+HSize,py+VSize);
			LineTo(hDC,px,py+VSize);
			LineTo(hDC,px,py);
			GetCursorPos(&pt2);
			ScreenToClient(_hWnd,&pt2);
			IsFirst=FALSE;
/*			if (IsDragging)
			{
				POINT	c_pt;
				ScreenToClient(_hWnd,&c_pt);
				c_pt.x=lPar&0xFFFF;
				c_pt.y=(lPar&0xFFFF0000)>>16;
				if ((c_pt.x!=pt2.x)||(c_pt.y!=pt2.y))
				{
				if (!IsFirst)
					BitBlt(hDC,pt2.x,pt2.y,abs(HSize)+1,abs(VSize)+1,hprDC,0,0,SRCCOPY);
				HSize=-(s_pt.x-c_pt.x);
				VSize=-(s_pt.y-c_pt.y);
				HSize=abs(HSize);
				VSize=abs(VSize);
				SendMessage(pre_wnd,WM_RC_PREVSIZE,0,0);
				HSize=-(s_pt.x-c_pt.x);
				VSize=-(s_pt.y-c_pt.y);
				if ((c_pt.x>s_pt.x)&&(c_pt.y>s_pt.y))
				{
					BitBlt(hprDC,0,0,abs(HSize)+1,abs(VSize)+1,hDC,s_pt.x,s_pt.y,SRCCOPY);
					pt2.x=s_pt.x; pt2.y=s_pt.y;
				}
				else
				if ((c_pt.x>s_pt.x)&&(c_pt.y<s_pt.y))
				{
					BitBlt(hprDC,0,0,abs(HSize)+2,abs(VSize)+2,hDC,s_pt.x,c_pt.y-s_pt.y,SRCCOPY);
//					BitBlt(hprDC,0,0,abs(HSize)+1,abs(VSize)+1,hDC,0,0,SRCCOPY);
					pt2.x=s_pt.x; pt2.y=s_pt.y-c_pt.y;
				}
				else
				if ((c_pt.x<s_pt.x)&&(c_pt.y>s_pt.y))
				{
					BitBlt(hprDC,0,0,abs(HSize)+2,abs(VSize)+2,hDC,s_pt.x-c_pt.x,s_pt.y,SRCCOPY);
//					BitBlt(hprDC,0,0,abs(HSize)+1,abs(VSize)+1,hDC,0,0,SRCCOPY);
					pt2.x=s_pt.x-c_pt.x; pt2.y=s_pt.y;
				}
				else
				if ((c_pt.x<s_pt.x)&&(c_pt.y<s_pt.y))
				{
					BitBlt(hprDC,0,0,abs(HSize)+1,abs(VSize)+1,hDC,c_pt.x,c_pt.y,SRCCOPY);
					pt2.x=c_pt.x; pt2.y=c_pt.y;
				}

				MoveToEx(hDC,s_pt.x,s_pt.y,0);
				LineTo(hDC,s_pt.x+HSize,s_pt.y);
				LineTo(hDC,s_pt.x+HSize,s_pt.y+VSize);
				LineTo(hDC,s_pt.x,      s_pt.y+VSize);
				LineTo(hDC,s_pt.x,      s_pt.y);
				IsFirst=FALSE;
				}
			}*/
		} 
		break;
	case WM_COMMAND:
		switch(LOWORD(wPar))
		{		
		case IDM_EXIT:	
			SaveWindowPos(GetWindowInfo(hwnd),WND_MAIN);	
			DeleteDC(hCompDC);
			DeleteDC(hDC);
			DeleteObject(hbitmap);
			if (IsIntray)
				TrayMessage(hwnd,NIM_DELETE,MAINTRAYICON,LoadIcon(_hInst,"MAINICON"),"RC1 Image Codec");
			PostQuitMessage(0);
			break;
		case IDM_HELP:
			ShellExecute(hwnd,NULL,stdir,NULL,NULL,SW_SHOWNORMAL);
			break;
		case IDM_OPEN:
			ClearFilter();
			AddFilter("   RC1 (*.rc1)","*.rc1");
			AddFilter("   BMP (*.bmp)","*.bmp");
			AddFilter("  (*.rc1;*.bmp)","*.rc1;*.bmp"); 
			AddFilter("  (*.*)","*.*");
			if (!GetFileName(OPEN,hwnd," ",0,0))
				break;
			switch (GetCurrentFileType(files))
			{
			case FT_BITMAP: 
				SetCursor(LoadCursor(NULL,IDC_WAIT));
				hbitmap=LoadImage(NULL,files,IMAGE_BITMAP,0,0,LR_LOADFROMFILE);
				SelectObject(hCompDC,hbitmap);
				break;
			case FT_RC1:
			{
				RCImage tst(files,NULL);
				hbitmap=CreateCompatibleBitmap(hDC,tst.MaxXCoord+1,tst.MaxYCoord+1);
				SelectObject(hCompDC,hbitmap);
				for (temp=0; temp<=tst.MaxXCoord; temp++)
					for (temp1=0; temp1<=tst.MaxYCoord; temp1++)
						SetPixel(hCompDC,temp,temp1,tst.Image[temp][temp1]);
			} break;
			case FT_UNKNOWN:
				INFOMESSAGE(" ");
				return 0;
			}
			HorPos=0; VerPos=0;
			SetScrollPos(hwnd,SB_HORZ,HorPos,TRUE);
			SetScrollPos(hwnd,SB_VERT,VerPos,TRUE);
			caption[18]=0;
			lstrcat(caption,files);
			SetWindowText(_hWnd,caption);
			InvalidateRect(NULL,NULL,FALSE);
			SetCursor(LoadCursor(NULL,IDC_ARROW));
			IsOpen=TRUE;
			break;
		case IDM_SAVE:
			if (IsOpen)
			{
				ClearFilter();
				AddFilter("   RC1 (*.rc1)","*.rc1");
				AddFilter("   BMP (*.bmp)","*.bmp");
				AddFilter("  (*.rc1;*.bmp)","*.rc1;*.bmp"); 
				AddFilter("  (*.*)","*.*");
				char capt[255];
				GetWindowText(_hWnd,capt,255);
				SETTINGSTRUCT cs=GetSettings();
				if (!GetFileName(SAVE,hwnd," ",!cs.promt,0,ExtractFName(capt)))
					break;
				switch (GetCurrentFileType(files))
				{
				case FT_BITMAP:
					SaveBitmap(files);
					caption[18]=0;
					lstrcat(caption,files);
					SetWindowText(_hWnd,caption);
					break;
				case FT_RC1:
				{
					SetCursor(LoadCursor(NULL,IDC_WAIT));
					GetObject(hbitmap,sizeof(BITMAP),&bitmap);
					RCImage tst(bitmap.bmWidth-1, bitmap.bmHeight-1,NULL);
					for (temp=0; temp<=tst.MaxXCoord; temp++)
						for (temp1=0; temp1<=tst.MaxYCoord; temp1++)
							tst.Image[temp][temp1]=GetPixel(hCompDC,temp,temp1);
					set=GetSettings();
					tst.VDiff[0]=(1<<set.bpr)-1;		//MaxDifferentTones for Red
					tst.VDiff[1]=(1<<set.bpg)-1;		//MaxDifferentTones for Green
					tst.VDiff[2]=(1<<set.bpb)-1;		//MaxDifferentTones for Blue
					tst.VDiff[3]=255;					//MaxDifferentTones for Alpha
					tst.Tolerance=set.feeling;			//Quality of saving
					tst.QBluring=set.smooth;			//Quality of bluring
					tst.SaveImage(files);
					hbitmap=CreateCompatibleBitmap(hDC,tst.MaxXCoord,tst.MaxYCoord);
					SelectObject(hCompDC,hbitmap);
					for (temp=0; temp<=tst.MaxXCoord; temp++)
						for (temp1=0; temp1<=tst.MaxYCoord; temp1++)
							SetPixel(hCompDC,temp,temp1,tst.Image[temp][temp1]);
					caption[18]=0;
					lstrcat(caption,files);
					SetWindowText(_hWnd,caption);
					SetCursor(LoadCursor(NULL,IDC_ARROW));
				} break;
				case FT_UNKNOWN:
					INFOMESSAGE(" ");
					return FALSE;
				}
				break;
			} break;
		case IDM_SETUP_CODEC:
			codec_wnd=CreateDialog(_hInst,"OPTIONS_CODEC",hwnd,(DLGPROC)CodecDlgProc);
			ShowWindow(codec_wnd,SW_SHOWNORMAL);
			UpdateWindow(codec_wnd);
			break;
		case IDM_SETUP_INTERFACE:
			DialogBox(_hInst,"OPTIONS_INTERFACE",hwnd,(DLGPROC)InterfaceDlgProc);
			break;
		case IDM_ABOUT:
			DialogBox(_hInst,"ABOUT",hwnd,(DLGPROC)AboutDlgProc);
			break;	
		case IDM_RESTORE:					/// TRAY MENU ITEM
			ShowWindow(hwnd,SW_RESTORE);
			TrayMessage(hwnd,NIM_DELETE,MAINTRAYICON,LoadIcon(_hInst,"MAINICON"),"RC1 Image Codec");
			IsIntray=FALSE;
			break;
		case IDM_CREATELIST:
			list_wnd=CreateDialog(_hInst,"LIST",_hWnd,(DLGPROC)ListDlgProc);
			ShowWindow(list_wnd,SW_SHOWNORMAL);
			UpdateWindow(list_wnd);
			break;
		} break;
	case WM_SYSCOMMAND:
		switch (wPar)
		{
		case SC_ICON:
			set=GetSettings();
			if (set.tray)
			{
				ShowWindow(hwnd,SW_HIDE);
				TrayMessage(hwnd,NIM_ADD,MAINTRAYICON,LoadIcon(_hInst,"MAINICON"),"RC1 Image Codec");
				IsIntray=TRUE;		
			} break;
		case SC_CLOSE:
			SaveWindowPos(GetWindowInfo(hwnd),WND_MAIN);	
			DeleteDC(hCompDC);
			DeleteDC(hDC);
			DeleteObject(hbitmap);
			PostQuitMessage(0);
			break;
		} break;
	case MYWM_TRAYNOT:
		switch (lPar)
		{			
		case WM_LBUTTONDOWN:
			ShowWindow(hwnd,SW_RESTORE);
			TrayMessage(hwnd,NIM_DELETE,MAINTRAYICON,LoadIcon(_hInst,"MAINICON"),"RC1 Image Codec");
			IsIntray=FALSE;
			break;
		case WM_RBUTTONDOWN:
			POINT	a;
			DWORD	a_tmp;
			HMENU	popup;
			GetCursorPos(&a); 
			AppendMenu((popup=CreatePopupMenu()),MF_ENABLED|MF_STRING,IDM_RESTORE,"");
			AppendMenu(popup,MF_ENABLED|MF_STRING,IDM_EXIT,"");
			SetForegroundWindow(_hWnd);
			TrackPopupMenuEx(popup,TPM_LEFTALIGN|TPM_TOPALIGN|TPM_RIGHTBUTTON|TPM_LEFTBUTTON,a.x,a.y,hwnd,0);
			for (a_tmp=0; a_tmp<2; a_tmp++)
				DeleteMenu(popup,a_tmp,MF_BYPOSITION);
		}
		break;
	}
	if (set.tray==1)
		if (wPar!=SC_ICON)
			return DefWindowProc(hwnd,Mes,wPar,lPar);
		else return 0;
	else return DefWindowProc(hwnd,Mes,wPar,lPar); 
}


int WINAPI WinMain(HINSTANCE hInst, HINSTANCE hPrev,
				   LPSTR lpszParam, int nCmdShow)
{
	WNDCLASS	wndclass;
	HWND		hwnd;
	MSG			msg;
	WNDINFO		wp={0,0,100,100,0};
	
	_hInst=hInst;
	char AppName[]="RC1 Image Codec";
	wndclass.style=CS_HREDRAW|CS_VREDRAW;
	wndclass.lpfnWndProc=MainWndProc;
	wndclass.cbClsExtra=wndclass.cbWndExtra=0;
	wndclass.hInstance=hInst;
	wndclass.hIcon=LoadIcon(hInst,"MAINICON");
	wndclass.hCursor=LoadCursor(NULL,IDC_ARROW);
	wndclass.hbrBackground=(HBRUSH)GetStockObject(LTGRAY_BRUSH);
	wndclass.lpszMenuName="MAINMENU";
	wndclass.lpszClassName=AppName;

#ifdef TESTING_SPACE
//	WORD a=GetCharPos("c:\\aaa.bbb",'.',1);
//	char *rr=ExtractFName("c:\\abba\\autoexec.bat");
//	char *rr=StrUpr("qwertyuiopasdfghjklzxcvbnm__");
#endif

	if (!RegisterClass(&wndclass))
	{
		DANGMESSAGE("Can't register class");
		return 0;
	}
	hwnd=CreateWindow(AppName,AppName,WS_OVERLAPPEDWINDOW|WS_HSCROLL|
						WS_VSCROLL,
					  CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,
					  CW_USEDEFAULT,0,0,hInst,0);
	_hWnd=hwnd;
	if (!hwnd)
	{
		DANGMESSAGE("Can't create window");
		return 0;
	}			
	InitCommonControls();
	wp=RetrWindowPos(WND_MAIN);
	if (wp.state==WND_ZOOM)
		ShowWindow(hwnd,SW_MAXIMIZE);
	else
		if (wp.state==WND_ICON)
			ShowWindow(hwnd,SW_MINIMIZE);
		else
		{
			SetWindowPos(hwnd,HWND_TOP,wp.cx,wp.cy,wp.cw,wp.ch,0);
			ShowWindow(hwnd,nCmdShow);
		}
	hDC=GetDC(hwnd); 
	hCompDC=CreateCompatibleDC(hDC);
	UpdateWindow(hwnd);
	GetCurrentDirectory(300,stdir);
	lstrcat(stdir,"\\rcmenu.htm");
	while (GetMessage(&msg,0,0,0))
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	return msg.wParam;
}