// Settings.h
// SETTINGS ROUTINES FILE
// COPYRIGNT BY 3LblDEHb [Team 16]

#ifndef __settings_h
#define __settings_h

#define WND_MAIN			1
#define WND_SETUP_CODEC		2
#define WND_ABOUT			3
#define WND_LIST			4
#define WND_SETUP_INTERFACE	5
#define WND_DIRLIST			6

#define	WND_ZOOM			10
#define WND_ICON			11
#define	WND_NORM			12

typedef struct
{
	DWORD	feeling;
	DWORD	bpr,bpg,bpb,bpc;
	DWORD	smooth;
	DWORD	promt;
	DWORD	tray;
	DWORD	tray_on_code;
	DWORD	preview;
	int		hs,vs;
} SETTINGSTRUCT;

typedef struct
{
	DWORD	feeling;
	DWORD	bpr,bpg,bpb;
	DWORD	smooth;
	int		crc;
} ITEMSTRUCT;


typedef struct
{
	DWORD	cx;
	DWORD	cy;
	DWORD	ch;
	DWORD	cw;
	DWORD	state;	// now is reserved
} WNDINFO;

void SetSettings(SETTINGSTRUCT*);
void SetDefault(SETTINGSTRUCT *);

//////////////////////////////////////////////////////////
//    
//////////////////////////////////////////////////////////
void Initialize()
{
	SETTINGSTRUCT sc;
	sc.feeling=0;
	sc.bpc=sc.bpr=sc.bpg=sc.bpb=8;
	sc.smooth=0;
	sc.promt=0;
	sc.tray=0;
	sc.tray_on_code=sc.preview=0;
	SetSettings(&sc);
	SetDefault(&sc);
}

//////////////////////////////////////////////////////////
//    ini 
//////////////////////////////////////////////////////////
void SetSettings(SETTINGSTRUCT *ss)
{
	char wpathbuf[MAX_PATH+1];
	GetWindowsDirectory(wpathbuf,MAX_PATH+1);
	lstrcat(wpathbuf,"\\rc1.ini");
	WritePrivateProfileStruct("Settings","set",ss,sizeof(SETTINGSTRUCT),wpathbuf);
}

//////////////////////////////////////////////////////////
//    ini 
//////////////////////////////////////////////////////////
SETTINGSTRUCT GetSettings()
{
	SETTINGSTRUCT ss;
	char wpathbuf[MAX_PATH+1];
	GetWindowsDirectory(wpathbuf,MAX_PATH+1);
	lstrcat(wpathbuf,"\\rc1.ini");
	if (!GetPrivateProfileStruct("Settings","set",&ss,sizeof(SETTINGSTRUCT),wpathbuf))
	{
		Initialize();
		GetPrivateProfileStruct("Settings","set",&ss,sizeof(SETTINGSTRUCT),wpathbuf);
	}
	return ss;
}

//////////////////////////////////////////////////////////
//    
//////////////////////////////////////////////////////////
void SetDefault(SETTINGSTRUCT *ss)
{
	char wpathbuf[MAX_PATH+1];
	GetWindowsDirectory(wpathbuf,MAX_PATH+1);
	lstrcat(wpathbuf,"\\rc1.ini");
	WritePrivateProfileStruct("Default","set",ss,sizeof(SETTINGSTRUCT),wpathbuf);
}

//////////////////////////////////////////////////////////
//    
//////////////////////////////////////////////////////////
SETTINGSTRUCT GetDefault()
{
	SETTINGSTRUCT ss;
	char wpathbuf[MAX_PATH+1];
	GetWindowsDirectory(wpathbuf,MAX_PATH+1);
	lstrcat(wpathbuf,"\\rc1.ini");
	if (!GetPrivateProfileStruct("Default","set",&ss,sizeof(SETTINGSTRUCT),wpathbuf))
	{
		Initialize();
		GetPrivateProfileStruct("Default","set",&ss,sizeof(SETTINGSTRUCT),wpathbuf);
	}
	return ss;
}

//////////////////////////////////////////////////////////
//     (, , etc)
//////////////////////////////////////////////////////////
WNDINFO GetWindowInfo(HWND wnd)
{
	RECT			rc;
	WNDINFO			wp;
	GetWindowRect(wnd,&rc);
	wp.cx=rc.left;
	wp.cy=rc.top;
	wp.ch=rc.bottom-rc.top;
	wp.cw=rc.right-rc.left;
	if (IsZoomed(wnd)) wp.state=WND_ZOOM;
	else
		if (IsIconic(wnd)) wp.state=WND_ICON;
	else
		wp.state=WND_NORM;
	return wp;
}

//////////////////////////////////////////////////////////
//     ini 
//////////////////////////////////////////////////////////
void SaveWindowPos(WNDINFO wp,int window)
{
	char wpathbuf[MAX_PATH+1];
	char *sect;
	GetWindowsDirectory(wpathbuf,MAX_PATH+1);
	lstrcat(wpathbuf,"\\rc1.ini");
	switch (window)
	{
	case WND_MAIN:
		sect="Main";
		break;
	case WND_SETUP_CODEC:
		sect="Setup_codec";
		break;
	case WND_ABOUT:
		sect="About";
		break;
	case WND_LIST:
		sect="List";
		break;
	case WND_SETUP_INTERFACE:
		sect="Setup_interface";
		break;
	case WND_DIRLIST:
		sect="Dirlist";
		break;
	}
	WritePrivateProfileStruct("Position",sect,&wp,sizeof(WNDINFO),wpathbuf);
}

//////////////////////////////////////////////////////////
//   ini   
//////////////////////////////////////////////////////////
WNDINFO RetrWindowPos(int window)
{
	char wpathbuf[MAX_PATH+1];
	char *sect;
	WNDINFO wp;
	GetWindowsDirectory(wpathbuf,MAX_PATH+1);
	lstrcat(wpathbuf,"\\rc1.ini");
	switch (window)
	{
	case WND_MAIN:
		sect="Main";
		break;
	case WND_SETUP_CODEC:
		sect="Setup_codec";
		break;
	case WND_ABOUT:
		sect="About";
		break;
	case WND_LIST:
		sect="List";
		break;
	case WND_SETUP_INTERFACE:
		sect="Setup_interface";
		break;
	case WND_DIRLIST:
		sect="Dirlist";
		break;
	}
	if (!GetPrivateProfileStruct("Position",sect,&wp,sizeof(WNDINFO),wpathbuf))
	{
		wp.cx=10; wp.cy=10;
	}
	return wp;
}
#endif