//Copyright by SkyLord [TEAM16] (14.06.2000)
//kir@sch33.edu.yar.ru

//QuickSort    DwordArray.

//  VC++  C++Builder'   ,  
// ,   ,  .

#ifndef __Sorting_h
#define __Sorting_h

#include <windows.h>
// VC++     .

////////////////////////////////////////////////////////////////////////////////
//===DwordArray=================================================================
//  DWORD':
////////////////////////////////////////////////////////////////////////////////
class DwordArray
{
private:
	HGLOBAL block;
public:
	DWORD* Data;
//    -     ( ,   ,
//         ,  ,     
//      ReAlloc'  - AccessViolation ...)
	DWORD _IncSize;
//    -     ( !!!)
//      ( ,   ReAlloc'   ,   
//       "" - ReAlloc',    )
	DWORD _Size;
//    -    ( !!!)
	DWORD& operator [](DWORD Position)
	{
		ReSize(Position+1);
		return Data[Position];
	}
//    -        
//    -      
//    -         
//      ,  _IncSize,    ,  ,
//       ...   1!
	void ReSize(DWORD NewSize);
//    -    
	DwordArray()
	{
//  - 0,   - 256
		_Size=0;
		_IncSize=256;
	}
	~DwordArray()
	{
// 
		GlobalUnlock(block);
		GlobalFree(block);
	}
};
////////////////////////////////////////////////////////////////////////////////
void DwordArray::ReSize(DWORD NewSize)
{
	if(NewSize>_Size)
	{
//    ,  ...
		DWORD tmpSize=(((NewSize-1)/_IncSize)+1)*_IncSize;
		if(_Size==0)
//   0,       => Alloc'  ...
			block=GlobalAlloc(GMEM_MOVEABLE, tmpSize*sizeof(DWORD));
		else
//    0,      => ReAlloc'  ...
			block=GlobalReAlloc(block, tmpSize*sizeof(DWORD), GMEM_MOVEABLE);
		Data=(DWORD*)GlobalLock(block);
// ...  
		for(DWORD tmp=_Size; tmp<tmpSize; tmp++) Data[tmp]=0;
		_Size=tmpSize;
	}
}
////////////////////////////////////////////////////////////////////////////////
//End of DwordArray
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
//===_GlobalSortParam===========================================================
//    , ,  
//    .
////////////////////////////////////////////////////////////////////////////////
struct SortParam
{
	DWORD *ElementsPointer;
//       ,  
	DWORD *LinksPointer;
//       ,    
	DWORD StructSize;
//         
	DWORD StructOffset;
//            
	BYTE Vector;
//     
//    Vector=0 -   
//    Vector=1 -   
} _GlobalSortParam;
////////////////////////////////////////////////////////////////////////////////
//End of _GlobalSortParam
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
//===QSorting===================================================================
//  QuickSort',    C++Builder', 
//  .
//      ,    DWORD'
//   DWORD StartPos, StopPos
//      -     
////////////////////////////////////////////////////////////////////////////////
void QSorting(DWORD StartPos, DWORD StopPos)
{
	DWORD tmpMed;
	long newStart, newStop;
/*
   asm-:

	DWORD tSwap;
	tmpMed=_GlobalSortParam.ElementsPointer[_GlobalSortParam.LinksPointer[((StartPos+StopPos)>>1)]*4+1];
	newStart=StartPos;
	newStop=StopPos;
	do
	{
		while(_GlobalSortParam.ElementsPointer[_GlobalSortParam.LinksPointer[newStart]*4+1]<tmpMed)
			newStart++;
		while(_GlobalSortParam.ElementsPointer[_GlobalSortParam.LinksPointer[newStop]*4+1]>tmpMed)
			newStop--;
		if(newStart<=newStop)
		{
			tSwap=_GlobalSortParam.LinksPointer[newStart];
			_GlobalSortParam.LinksPointer[newStart]=_GlobalSortParam.LinksPointer[newStop];
			_GlobalSortParam.LinksPointer[newStop]=tSwap;
			newStart++;
			newStop--;
		}
	}
	while(newStart<=newStop);
	if(newStop>StartPos && newStop>=0) QSorting(StartPos, newStop);
	if(newStart<StopPos) QSorting(newStart, StopPos);
*/
	__asm
	{
		mov esi, dword ptr _GlobalSortParam.LinksPointer
		mov edi, dword ptr _GlobalSortParam.ElementsPointer
		add edi, dword ptr _GlobalSortParam.StructOffset
		mov edx, StartPos
		add edx, StopPos
		shr edx, 1
		mov eax, dword ptr [esi+4*edx]
		mov edx, dword ptr _GlobalSortParam.StructSize
		mul edx
		mov eax, dword ptr [edi+eax]
		mov tmpMed, eax
		mov ebx, StartPos
		mov ecx, StopPos
QSorting_Cycle:
		jmp QSorting_Cycle1_Start
QSorting_Cycle1:
		inc ebx
QSorting_Cycle1_Start:
		mov eax, dword ptr [esi+4*ebx]
		mov edx, dword ptr _GlobalSortParam.StructSize
		mul edx
		mov eax, dword ptr [edi+eax]
		cmp eax, tmpMed
		jb QSorting_Cycle1
		jmp QSorting_Cycle2_Start
QSorting_Cycle2:
		dec ecx
QSorting_Cycle2_Start:
		mov eax, dword ptr [esi+4*ecx]
		mov edx, dword ptr _GlobalSortParam.StructSize
		mul edx
		mov eax, dword ptr [edi+eax]
		cmp eax, tmpMed
		ja QSorting_Cycle2
		cmp ebx, ecx
		jg QSorting_Not
		mov eax, dword ptr [esi+4*ebx]
		mov edx, dword ptr [esi+4*ecx]
		mov dword ptr [esi+4*ecx], eax
		mov dword ptr [esi+4*ebx], edx
		inc ebx
		dec ecx
QSorting_Not:
		cmp ebx, ecx
		jle QSorting_Cycle
		mov newStop, ecx
		mov newStart, ebx
		cmp ecx, StartPos
		jle QSorting_Not1
	}
	QSorting(StartPos, newStop);
	__asm
	{
QSorting_Not1:
		cmp ebx, StopPos
		jge QSorting_Not2
	}
	QSorting(newStart, StopPos);
	__asm
	{
QSorting_Not2:
	}
}
////////////////////////////////////////////////////////////////////////////////
//End of QSorting
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
//===Sorting====================================================================
//  QuickSort'.
//   DWORD StartPos, StopPos
//      -     
//   BYTE ReWrite
//      -     
//        0 - 
//        1 - 
//      -      ,     
//
//     _GlobalSortParam.LinksPointer   
//      
////////////////////////////////////////////////////////////////////////////////
void Sorting(DWORD StartPos, DWORD StopPos, BYTE ReWrite)
{
	__asm
	{
		mov eax, StartPos
		mov esi, dword ptr _GlobalSortParam.LinksPointer
Sorting_Cycle1:
		mov dword ptr [esi+4*eax], eax
		cmp eax, StopPos
		inc eax
		jb Sorting_Cycle1
	}
	QSorting(StartPos, StopPos);
	DwordArray tmpArray;
	tmpArray.ReSize(StopPos*((_GlobalSortParam.StructSize>>2)+1));
	DWORD* pointer=tmpArray.Data;
	__asm
	{
		cmp _GlobalSortParam.Vector, 0
		je Sorting_Continue
		mov esi, dword ptr _GlobalSortParam.LinksPointer
		mov edx, StartPos
		add edx, StopPos
		shr edx, 1
		mov eax, StartPos
Sorting_AnotherVector:
		mov ecx, dword ptr [esi+4*eax]
		mov ebx, StopPos
		add ebx, StartPos
		sub ebx, eax
		xchg ecx, dword ptr [esi+4*ebx]
		mov dword ptr [esi+4*eax], ecx
		cmp eax, edx
		inc eax
		jb Sorting_AnotherVector
Sorting_Continue:
		cmp ReWrite, 1
		jne Sorting_End
		mov eax, StartPos
		mov esi, dword ptr _GlobalSortParam.ElementsPointer
		mov edi, pointer
		push StartPos
		mov eax, StartPos
		mul _GlobalSortParam.StructSize
		mov StartPos, eax
		mov eax, StopPos
		inc eax
		mul _GlobalSortParam.StructSize
		dec eax
Sorting_Cycle2:
		mov dl, byte ptr [esi+eax]
		mov byte ptr [edi+eax], dl
		cmp eax, StartPos
		dec eax
		ja Sorting_Cycle2
		pop StartPos
		mov eax, StartPos
		mov ebx, dword ptr _GlobalSortParam.LinksPointer
Sorting_Cycle3:
		push eax
		mov eax, dword ptr [ebx+4*eax]
		mul _GlobalSortParam.StructSize
		push edi
		add edi, eax
		mov eax, dword ptr _GlobalSortParam.StructSize
		dec eax
Sorting_Cycle3_1:
		mov cl, byte ptr [edi+eax]
		mov byte ptr [esi+eax], cl
		cmp eax, 0
		dec eax
		ja Sorting_Cycle3_1
		add esi, dword ptr _GlobalSortParam.StructSize
		pop edi
		pop eax
		cmp eax, StopPos
		inc eax
		jbe Sorting_Cycle3
Sorting_End:
	}
}
////////////////////////////////////////////////////////////////////////////////
//End of Sorting
////////////////////////////////////////////////////////////////////////////////

#endif
/*
//EXAMPLE

DwordArray TA;
//TA = {NULL}
TA[5]=10;
//TA.Data = {0, 0, 0, 0, 0, 10}
TA[3]=5;
//TA.Data = {0, 0, 0, 5, 0, 10}
TA.ReSize(3);
//TA.Data = {0, 0, 0, 5, 0, 10}
TA.ReSize(7);
//TA.Data = {0, 0, 0, 5, 0, 10, 0}

DwordArray LINKS;
LINKS.ReSize(7);
//LINKS.Data = {0, 0, 0, 0, 0, 0, 0}
_GlobalSortParam.ElementsPointer=(DWORD*) TA.Data;
_GlobalSortParam.LinksPointer=LINKS.Data;
_GlobalSortParam.StructSize=4;
_GlobalSortParam.StructOffset=0;
_GlobalSortParam.Vector=0;
Sorting(0, 6, 0);
//TA.Data = {0, 0, 0, 5, 0, 10, 0}
//LINKS.Data = {0, 1, 2, 4, 6, 3, 5}
_GlobalSortParam.Vector=1;
Sorting(0, 6, 1);
//TA.Data = {10, 5, 0, 0, 0, 0, 0}
//LINKS.Data = {5, 3, 6, 4, 2, 1, 0}
*/
