unit main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ImgList, FTPSock, Ftp, ComCtrls, FtpListView, FtpTreeView, ToolWin,
  StdCtrls, FtpMsg, ExtCtrls;

type
  TfrmMain = class(TForm)
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    MFtpTreeView1: TMFtpTreeView;
    MFtp1: TMFtp;
    ImageList1: TImageList;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    ToolButton8: TToolButton;
    ToolButton9: TToolButton;
    ToolButton10: TToolButton;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    ToolButton11: TToolButton;
    ToolButton12: TToolButton;
    ToolButton13: TToolButton;
    Splitter1: TSplitter;
    Notebook1: TNotebook;
    MFtpListView1: TMFtpListView;
    Splitter2: TSplitter;
    MFtpMessenger1: TMFtpMessenger;
    ProgressBar1: TProgressBar;
    procedure ToolButton10Click(Sender: TObject);
    procedure ToolButton8Click(Sender: TObject);
    procedure ToolButton1Click(Sender: TObject);
    procedure ToolButton2Click(Sender: TObject);
    procedure MFtp1FtpBusy(Sender: TObject);
    procedure MFtp1FtpReady(Sender: TObject);
    procedure MFtp1LoggedIn(Sender: TObject);
    procedure MFtp1DirectoryChanged(Sender: TObject);
    procedure MFtp1ContentChanged(Sender: TObject);
    procedure ToolButton6Click(Sender: TObject);
    procedure MFtpListView1DblClick(Sender: TObject);
    procedure MFtpListView1Edited(Sender: TObject; Item: TListItem;
      var S: String);
    procedure ToolButton11Click(Sender: TObject);
    procedure ToolButton4Click(Sender: TObject);
    procedure ToolButton5Click(Sender: TObject);
    procedure MFtp1FtpInfo(Sender: TObject; info: FtpInfo;
      addinfo: String);
    procedure MFtp1FtpQuit(Sender: TObject);
    procedure MFtpListView1FileDropped(Sender: TObject);
    procedure MFtp1FtpError(Sender: TObject; error: FtpError;
      addinfo: String);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;

function Strip(S: String): String;

implementation

{$R *.DFM}

procedure TfrmMain.ToolButton10Click(Sender: TObject);
begin
   MFtp1.Abort;
end;

procedure TfrmMain.ToolButton8Click(Sender: TObject);
begin
   MFtp1.ChangeToParentDirectory;
end;

procedure TfrmMain.ToolButton1Click(Sender: TObject);
var S: String;
begin
   with MFtp1 do
   begin
      if Connected then Exit;

      S := Server;
      if InputQuery('FTP Panel', 'Where do you want to go?', S) then
      begin
         Server := S;
         Login;
      end;
   end;
end;

procedure TfrmMain.ToolButton2Click(Sender: TObject);
begin
   MFtp1.Disconnect;
end;

procedure TfrmMain.MFtp1FtpBusy(Sender: TObject);
begin
   Cursor := crDefault;
   MFtpListView1.Accept := False;
end;

procedure TfrmMain.MFtp1FtpReady(Sender: TObject);
begin
   Cursor := crDefault;
   ProgressBar1.Visible := False;
   MFtpListView1.Accept := True;
end;

procedure TfrmMain.MFtp1LoggedIn(Sender: TObject);
begin
   MFtp1.Refresh;
end;

procedure TfrmMain.MFtp1DirectoryChanged(Sender: TObject);
begin
   MFtp1.Refresh;
end;

procedure TfrmMain.MFtp1ContentChanged(Sender: TObject);
begin
   {we want to refresh cache}
   with MFtp1 do
   begin
      Cache := False;
      Refresh;
      Cache := True;
   end;
end;

procedure TfrmMain.ToolButton6Click(Sender: TObject);
begin
   if MFtpListview1.SelectedFiles.Count > 0 then
      MFtp1.DeleteFile(MFtpListview1.SelectedFiles[0]);

   if MFtpListview1.SelectedDirectories.Count > 0 then
      MFtp1.DeleteDirectory(MFtpListview1.SelectedDirectories[0]);
end;

procedure TfrmMain.MFtpListView1DblClick(Sender: TObject);
begin
   if MFtpListview1.SelectedDirectories.Count > 0 then
      MFtp1.ChangeDirectory(MFtpListview1.SelectedDirectories[0]);
end;

procedure TfrmMain.MFtpListView1Edited(Sender: TObject; Item: TListItem;
  var S: String);
begin
   MFtp1.RenameFile(Item.Caption, S);
end;

procedure TfrmMain.ToolButton11Click(Sender: TObject);
var S: String;
begin
   if InputQuery('FTP Panel', 'What name is the new directory?', S) then
      MFtp1.CreateDirectory(S);
end;

procedure TfrmMain.ToolButton4Click(Sender: TObject);
begin
   if MFtpListview1.SelectedFiles.Count > 0 then
   begin
      with SaveDialog1 do
      begin
         Filename := MFtpListview1.SelectedFiles[0];
         if Execute then MFtp1.GetFile(MFtpListview1.SelectedFiles[0], Filename);
         ProgressBar1.Visible := True;
      end;
   end;
end;

procedure TfrmMain.ToolButton5Click(Sender: TObject);
begin
   with OpenDialog1 do
   begin
      if Execute then
      begin
         MFtp1.PutFile(Filename, Strip(Filename));
         ProgressBar1.Visible := True;
      end;
   end;
end;

procedure TfrmMain.MFtp1FtpInfo(Sender: TObject; info: FtpInfo;
  addinfo: String);
begin
   case info of
      ftpDataTrace:
         if ProgressBar1.Visible then
            ProgressBar1.Position := MFtp1.BytesTransferred;
      ftpFileSize:
         ProgressBar1.Max := StrToInt(addinfo);
   end;
end;

procedure TfrmMain.MFtp1FtpError(Sender: TObject; error: FtpError;
  addinfo: String);
begin
   ProgressBar1.Visible := False;
end;

procedure TfrmMain.MFtp1FtpQuit(Sender: TObject);
begin
   MFtpTreeView1.Sites.Clear;
   MFtpListView1.Items.Clear;
end;

procedure TfrmMain.MFtpListView1FileDropped(Sender: TObject);
begin
   MFtp1.PutFile(MFtpListView1.FileDropped[0], Strip(MFtpListView1.FileDropped[0]));
   ProgressBar1.Visible := True;
end;

function Strip;
var i: Integer;
begin
   if Pos('\', S) > 0 then
   begin
      for i := Length(S) downto 1 do
         if S[i] = '\' then Break;

      Result := Copy(S, i + 1, 999);
   end
   else
      Result := S;
end;

end.
