// Label.cpp : implementation file
//
// Class CLabel is extension of CStatic and enable
// change color, font's attributes and mouse cursor
//
// Author: German Madyarov
// http://mga.webjump.com
// mga@kbb.kemerovo.su
/////////////////////////////////////////////////////////////////////////
#include "stdafx.h"
#include "Label.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CLabel

CLabel::CLabel()
{
	m_hCursor=NULL;
	m_bktransparent=FALSE;
	m_color=RGB(0,0,0);
	m_bkcolor=RGB(192,192,192);

	hbr = CreateSolidBrush(m_bkcolor);

	::GetObject((HFONT)GetStockObject(DEFAULT_GUI_FONT),
		sizeof(m_lf),&m_lf);
	m_font.CreateFontIndirect(&m_lf);

	

}

CLabel::~CLabel()
{
	m_font.DeleteObject();
	if( hbr!=NULL )
		DeleteObject(hbr);
}


BEGIN_MESSAGE_MAP(CLabel, CStatic)
	//{{AFX_MSG_MAP(CLabel)
	ON_WM_CTLCOLOR_REFLECT()
	ON_WM_SETCURSOR()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CLabel message handlers


void CLabel::SetColor(COLORREF forecolor,COLORREF backcolor)
{
	m_color=forecolor;
	m_bkcolor=backcolor;
	if( hbr!=NULL )
		DeleteObject(hbr);
	if(m_bktransparent)
	{
		LOGBRUSH lb;
		lb.lbStyle=BS_HOLLOW;
		hbr = CreateBrushIndirect(&lb);
	}
	else
		hbr = CreateSolidBrush(m_bkcolor);
	
	RedrawWindow();
}

HBRUSH CLabel::CtlColor(CDC* pDC, UINT nCtlColor) 
{
	// TODO: Change any attributes of the DC here
	pDC->SetTextColor(m_color);
	
	if(m_bktransparent)
		pDC->SetBkMode(TRANSPARENT);
	else
		pDC->SetBkColor(m_bkcolor);
	
	// TODO: Return a different brush if the default is not desired
	return hbr;
}



void CLabel::SetLabelFont(long size, BOOL bold, BOOL italic, BOOL underline)
{
	m_lf.lfHeight=size;
	if(bold)
		m_lf.lfWeight=FW_BOLD;
	else
		m_lf.lfWeight=FW_NORMAL;

	m_lf.lfItalic=italic;
	m_lf.lfUnderline=underline;
	
	m_font.DeleteObject();
	m_font.CreateFontIndirect(&m_lf);
	SetFont(&m_font);
	//RedrawWindow();
}

BOOL CLabel::OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message) 
{
	// TODO: Add your message handler code here and/or call default
	if( m_hCursor==NULL )
		return CStatic::OnSetCursor(pWnd, nHitTest, message);

	::SetCursor(m_hCursor);
	return TRUE;
}

void CLabel::SetLabelCursor(WORD idCursor)
{
	if(idCursor==NULL)
		m_hCursor=NULL;
	else
		m_hCursor=LoadCursor(AfxGetApp()->m_hInstance,
		MAKEINTRESOURCE(idCursor));
}
