// Pop3Client.cpp: implementation of the CPop3Client class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Pop3Client.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

#define POP3_PORT 110
//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CPop3Client::CPop3Client()
{
	m_socket=socket(AF_INET, SOCK_STREAM,0);
}

CPop3Client::~CPop3Client()
{
	if( m_socket!=INVALID_SOCKET )
	{
		closesocket(m_socket);
		m_socket=INVALID_SOCKET;
	}
}

BOOL CPop3Client::Connect(LPCTSTR hostname)
{
	sockaddr_in addr_serv;
	addr_serv.sin_family=AF_INET;
	addr_serv.sin_port=htons(POP3_PORT);
	
	hostent* he=gethostbyname(hostname);
	memcpy(&addr_serv.sin_addr,he->h_addr,he->h_length);

	if( connect(m_socket,(sockaddr*)&addr_serv,sizeof(sockaddr)) )
	{
		m_message.Format("connect() failed with error %d\n",WSAGetLastError());
		return FALSE;
	}
	
	memset(transfer_buf,0,sizeof(transfer_buf));
	int result=recv(m_socket,transfer_buf,sizeof(transfer_buf),0);
	if( result==SOCKET_ERROR )
	{
		m_message.Format("recv() is failed with WinSock error #%d",
			WSAGetLastError());
		return FALSE;
	}
	memset(&transfer_buf[result-2],0,1);
	m_message=transfer_buf;

	if( strncmp(transfer_buf,"+OK",3) )
	{
		return FALSE;
	}

	return TRUE;
}

void CPop3Client::Disconnect()
{
	if( m_socket!=INVALID_SOCKET )
	{
		closesocket(m_socket);
		m_socket=INVALID_SOCKET;
	}
}

BOOL CPop3Client::Login(LPCTSTR user, LPCTSTR password)
{
	CString m_string="USER ";
	m_string=m_string+user;

	if( !SendCommand(m_string) )
		return FALSE;
	if( !RecvAnswer() )
		return FALSE;

	m_string="PASS ";
	m_string=m_string+password;

	if( !SendCommand(m_string) )
		return FALSE;
	if( !RecvAnswer() )
		return FALSE;

	if( AfxExtractSubString(m_string,m_message,3,' ') )
		m_messcount=atoi(m_string);
	else
		m_messcount=0;
	
	return TRUE;
}

CString CPop3Client::GetMessage()
{
	return m_message;
}

BOOL CPop3Client::SendCommand(LPCTSTR command)
{
	memset(transfer_buf,0,sizeof(transfer_buf));
	strcpy(transfer_buf,command);
	strcpy(&transfer_buf[strlen(command)],"\r\n");

	if( send(m_socket,transfer_buf,strlen(command)+2,0)==SOCKET_ERROR )
	{
		m_message.Format("sending command %s is failed with WinSock error #%d",
			command,WSAGetLastError());
		return FALSE;
	}
	return TRUE;
}

BOOL CPop3Client::RecvAnswer()
{
	memset(transfer_buf,0,sizeof(transfer_buf));
	int result=recv(m_socket,transfer_buf,sizeof(transfer_buf),0);
	if( result==SOCKET_ERROR )
	{
		m_message.Format("recv() is failed with WinSock error #%d",
			WSAGetLastError());
		return FALSE;
	}
	memset(&transfer_buf[result-2],0,1);
	m_message=transfer_buf;

	if( strncmp(transfer_buf,"+OK",3) )
	{
		return FALSE;
	}

	return TRUE;
}

BOOL CPop3Client::Retr(unsigned int id,char* message)
{
	if( id>m_messcount )
	{
		m_message.Format("Not exist message %d",id);
		return FALSE;
	}

	CString m_string;
	m_string.Format("RETR %d",id);
	if( !SendCommand(m_string) )
		return FALSE;

	int size=0;
	int result=1;

	while( result!=0 )
	{
		result=recv(m_socket,message+size,4096,0);
		if( result==SOCKET_ERROR )
		{
			m_message.Format("recv() is failed with WinSock error #%d",
			WSAGetLastError());
			return FALSE;
			break;
		}
		size=size+result;
		if( !strncmp(message+size-5,"\r\n.\r\n",3) )
		{
			memset(message+size-3,0,1);
			size=size-3;
			break;
		}
	}

	m_string=message;
	//m_string=&message[m_string.Find("\r\n")+1];
	strcpy(message,&message[m_string.Find("\r\n")+2]);
	return TRUE;

}

unsigned int CPop3Client::GetMessageSize(unsigned int id)
{
	CString m_string;
	m_string.Format("LIST %d",id);

	if( !SendCommand(m_string) )
		return 0;
	if( !RecvAnswer() )
		return 0;
	
	if(!AfxExtractSubString(m_string,m_message,2,' ') )
		return 0;

	return atoi(m_string);
}
