unit FtpClasses;

interface

uses Classes, SysUtils, Ftp, FtpData;

type
   TMFtpSearch = class
   private
      FBusy:                     Boolean;
      FURL:                      String;

      FOnReady:                  TNotifyEvent;
      FOnFileFound:              TMFtpFileFoundEvent;

      procedure ParseFTPSearchFile(S: String);
   public
      property Busy: Boolean read FBusy;
      property FTPSearchURL: String read FURL write FURL;

      constructor Create;
      procedure Search(LookFor: String);
   end;

implementation

constructor TMFtpSearch.Create;
begin
   inherited Create;

   FBusy := False;
   FURL := 'http://lycos.ftpsearch.com/';
end;

procedure TMFtpSearch.Search;
begin
   if FBusy then Exit;

   LookFor := Trim(LookFor);
   if LookFor = '' then Exit;
end;

procedure TMFtpSearch.ParseFTPSearchFile(S: String);
var i, j: Integer;
    P, Attrib, Size, Date: String;
    Buf: TStrings;
begin
   Buf := TStringList.Create;
   
   try
      Buf.LoadFromFile(S);

      for i := 0 to Buf.Count - 1 do
      begin
         if Pos('<A HREF="ftp://', Buf[i]) > 0 then
         begin            
            P := Buf[i];

            {
               Here is a sample line:

                 1 <TT>-r--r--r--</TT> <B>  10.9M</B> 1998 Oct 22 <A HREF="/ftpsearch?type=Navigate&query=ftp%2ecdrom%2ecom%2f">ftp.cdrom.com</A>        <A HREF="/ftpsearch?type=Navigate&query=ftp%2ecdrom%2ecom%2f%2e3%2fgamesdomain%2fdemos">/.3/gamesdomain/demos</A>/<A HREF="ftp://ftp.cdrom.com/.3/gamesdomain/demos/Win2000.exe">Win2000.exe</A>
            }

            // Attribute
            j := Pos('<TT>', P);
            Delete(P, 1, j + 3);
            j := Pos('</TT>', P);
            Attrib := Copy(P, 1, j - 1);

            // Size
            j := Pos('<B>', P);
            Delete(P, 1, j + 2);
            j := Pos('</B>', P);
            Size := Trim(Copy(P, 1, j - 1));
            Delete(P, 1, j + 3);

            // Date
            j := Pos('<A HREF', P);
            Date := Trim(Copy(P, 1, j - 1));

            // URL
            j := Pos('<A HREF="ftp://', P);
            Delete(P, 1, j + 8);
            j := Pos('">', P);
            Delete(P, j, 999);
         end;
      end;
   except
   end;

   Buf.Free;
end;

end.

