// SmtpClient.cpp: implementation of the CSmtpClient class.
//
// This class allow you send email to SMTP-server
// by using WinSock2 API
//
// MGASoftware (c)2000
// http://mga.webjump.com
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "SmtpClient.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

#define SMTP_PORT 25
//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CSmtpClient::CSmtpClient()
{
	m_socket=socket(AF_INET, SOCK_STREAM,0);
}

CSmtpClient::~CSmtpClient()
{
	if( m_socket!=INVALID_SOCKET )
	{
		closesocket(m_socket);
		m_socket=INVALID_SOCKET;
	}
}


BOOL CSmtpClient::Connect(LPCTSTR hostname,LPCTSTR UserForHelo)
{
	sockaddr_in addr_serv;
	addr_serv.sin_family=AF_INET;
	addr_serv.sin_port=htons(SMTP_PORT);
	
	hostent* he=gethostbyname(hostname);
	memcpy(&addr_serv.sin_addr,he->h_addr,he->h_length);

	if( connect(m_socket,(sockaddr*)&addr_serv,sizeof(sockaddr)) )
	{
		m_message.Format("connect() failed with error %d\n",WSAGetLastError());
		return FALSE;
	}

	if(!RecvAnswer("220") )
		return FALSE;

	m_message="HELO ";
	m_message=m_message+UserForHelo;

	if( !SendCommand(m_message) )
		return FALSE;

	if( !RecvAnswer("250") )
		return FALSE;

	return TRUE;

}

BOOL CSmtpClient::SendMail(LPCTSTR MailFrom, LPCTSTR RcptTo, char *pBody, unsigned int size)
{
	m_message="MAIL FROM:<";
	m_message=m_message+MailFrom;
	m_message=m_message+">";

	if( !SendCommand(m_message) )
		return FALSE;

	if( !RecvAnswer("250") )
		return FALSE;

	m_message="RCPT TO:<";
	m_message=m_message+RcptTo;
	m_message=m_message+">";

	if( !SendCommand(m_message) )
		return FALSE;

	if( !RecvAnswer("250") )
		return FALSE;

	if( !SendCommand("DATA") )
		return FALSE;

	if( !RecvAnswer("354") )
		return FALSE;

	if( send(m_socket,pBody,size,0)==SOCKET_ERROR )
	{
		m_message.Format("send() failed with WinSock error #%d",
			WSAGetLastError());
		return FALSE;
	}

	if( !SendCommand("\r\n.\r\n") )
		return FALSE;

	if( !RecvAnswer("250") )
		return FALSE;

	return TRUE;
}

BOOL CSmtpClient::SendCommand(LPCTSTR command)
{
	memset(transfer_buf,0,sizeof(transfer_buf));
	strcpy(transfer_buf,command);
	strcpy(&transfer_buf[strlen(command)],"\r\n");

	if( send(m_socket,transfer_buf,strlen(command)+2,0)==SOCKET_ERROR )
	{
		m_message.Format("sending command %s is failed with WinSock error #%d",
			command,WSAGetLastError());
		return FALSE;
	}
	return TRUE;
}

BOOL CSmtpClient::RecvAnswer(LPCTSTR code_success)
{
	memset(transfer_buf,0,sizeof(transfer_buf));
	int result=recv(m_socket,transfer_buf,sizeof(transfer_buf),0);
	if( result==SOCKET_ERROR )
	{
		m_message.Format("recv() is failed with WinSock error #%d",
			WSAGetLastError());
		return FALSE;
	}
	memset(&transfer_buf[result-2],0,1);
	m_message=transfer_buf;

	if( strncmp(transfer_buf,code_success,3) )
	{
		return FALSE;
	}

	return TRUE;
}

void CSmtpClient::Disconnect()
{
	if( m_socket!=INVALID_SOCKET )
	{
		closesocket(m_socket);
		m_socket=INVALID_SOCKET;
	}
}
